﻿namespace TestLibrary
{
    /// <summary>
    /// 테두리
    /// </summary>
    public class Border
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 테두리 스타일
        /// </summary>
        private BorderStyle style;

        /// <summary>
        /// 테두리 너비
        /// </summary>
        private float width;

        /// <summary>
        /// 테두리 색상 설명자
        /// </summary>
        private ColorDescriptor colorDescriptor;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 테두리 스타일 - Style

        /// <summary>
        /// 테두리 스타일
        /// </summary>
        public BorderStyle Style
        {
            get
            {
                return this.style;
            }
            set
            {
                this.style = value;
            }
        }

        #endregion
        #region 테두리 너비 - Width

        /// <summary>
        /// 테두리 너비
        /// </summary>
        public float Width
        {
            get
            {
                return this.width;
            }
            set
            {
                this.width = value;
            }
        }

        #endregion
        #region 테두리 색상 설명자 - ColorDescriptor

        /// <summary>
        /// 테두리 색상 설명자
        /// </summary>
        public ColorDescriptor ColorDescriptor
        {
            get
            {
                return this.colorDescriptor;
            }
            set
            {
                this.colorDescriptor = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region 생성자 - Border()

        /// <summary>
        /// 생성자
        /// </summary>
        internal Border()
        {
            this.style           = BorderStyle.None;
            this.width           = 0.5f;
            this.colorDescriptor = new ColorDescriptor(0);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 해시 코드 구하기 - GetHashCode()

        /// <summary>
        /// 해시 코드 구하기
        /// </summary>
        /// <returns>해시 코드</returns>
        public override int GetHashCode()
        {
            return this.width.GetHashCode() * 1000 + (int) this.style;
        }

        #endregion
        #region 동일 여부 구하기 - Equals(source)

        /// <summary>
        /// 동일 여부 구하기
        /// </summary>
        /// <param name="source">소스 객체</param>
        /// <returns>동일 여부</returns>
        public override bool Equals(object source)
        {
            Border sourceBorder = (Border)source;

            return (Style == sourceBorder.Style && Width == sourceBorder.Width);
        }

        #endregion
    }
}