﻿using System;

namespace TestLibrary
{
    /// <summary>
    /// 테두리들
    /// </summary>
    public class Borders
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 테두리 배열
        /// </summary>
        private Border[] borderArray;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 인덱서 - this[direction]

        /// <summary>
        /// 인덱서
        /// </summary>
        /// <param name="direction">방향</param>
        /// <returns>테두리</returns>
        public Border this[Direction direction]
        {
            get
            {
                int i = (int)direction;

                if(i >= 0 && i < this.borderArray.Length)
                {
                    return this.borderArray[i];
                }

                throw new Exception("Not a valid direction.");
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region 생성자 - Borders()

        /// <summary>
        /// 생성자
        /// </summary>
        internal Borders()
        {
            this.borderArray = new Border[4];

            for(int i = 0; i < this.borderArray.Length; i++)
            {
                this.borderArray[i] = new Border();
            }
        }

        #endregion
    }
}