﻿namespace TestLibrary
{
    /// <summary>
    /// 셀 마진 정보
    /// </summary>
    internal class CellMergeInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 행 인덱스
        /// </summary>
        private int rowIndex;

        /// <summary>
        /// 행 범위
        /// </summary>
        private int rowSpan;

        /// <summary>
        /// 열 인덱스
        /// </summary>
        private int columnIndex;

        /// <summary>
        /// 열 범위
        /// </summary>
        private int columnSpan;

        /// <summary>
        /// 대표 셀
        /// </summary>
        private RTFTableCell representativeCell;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region 행 인덱스 - RowIndex

        /// <summary>
        /// 행 인덱스
        /// </summary>
        internal int RowIndex
        {
            get
            {
                return this.rowIndex;
            }
        }

        #endregion
        #region 행 범위 - RowSpan

        /// <summary>
        /// 행 범위
        /// </summary>
        internal int RowSpan
        {
            get
            {
                return this.rowSpan;
            }
        }

        #endregion
        #region 열 인덱스 - ColumnIndex

        /// <summary>
        /// 열 인덱스
        /// </summary>
        internal int ColumnIndex
        {
            get
            {
                return this.columnIndex;
            }
        }

        #endregion
        #region 열 범위 - ColumnSpan

        /// <summary>
        /// 열 범위
        /// </summary>
        internal int ColumnSpan
        {
            get
            {
                return this.columnSpan;
            }
        }

        #endregion
        #region 대표 셀 - RepresentativeCell

        /// <summary>
        /// 대표 셀
        /// </summary>
        internal RTFTableCell RepresentativeCell
        {
            get
            {
                return this.representativeCell;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region 생성자 - CellMergeInfo(rowIndex, rowSpan, columnIndex, columnSpan, representativeCell)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="rowIndex">행 인덱스</param>
        /// <param name="rowSpan">행 범위</param>
        /// <param name="columnIndex">열 인덱스</param>
        /// <param name="columnSpan">열 범위</param>
        /// <param name="representativeCell">대표 셀</param>
        internal CellMergeInfo(int rowIndex, int rowSpan, int columnIndex, int columnSpan, RTFTableCell representativeCell)
        {
            this.rowIndex           = rowIndex;
            this.rowSpan            = rowSpan;
            this.columnIndex        = columnIndex;
            this.columnSpan         = columnSpan;
            this.representativeCell = representativeCell;
        }

        #endregion
    }
}