﻿using System;

namespace TestLibrary
{
    /// <summary>
    /// 마진들
    /// </summary>
    public class Margins
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 마진 배열
        /// </summary>
        private float[] marginArray;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 인덱서 - this[direction]

        /// <summary>
        /// 인덱서
        /// </summary>
        /// <param name="direction">방향</param>
        /// <returns>마진</returns>
        public float this[Direction direction]
        {
            get
            {
                int i = (int)direction;

                if(i >= 0 && i < this.marginArray.Length)
                {
                    return this.marginArray[i];
                }

                throw new Exception("Not a valid direction.");
            }
            set
            {
                int i = (int)direction;

                if(i >= 0 && i < this.marginArray.Length)
                {
                    this.marginArray[i] = value;
                }
                else
                {
                    throw new Exception("Not a valid direction.");
                }
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region 생성자 - Margins()

        /// <summary>
        /// 생성자
        /// </summary>
        internal Margins()
        {
            this.marginArray = new float[4];
        }

        #endregion
        #region 생성자 - Margins(top, right, bottom, left)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="top">위쪽</param>
        /// <param name="right">오른쪽</param>
        /// <param name="bottom">아래쪽</param>
        /// <param name="left">왼쪽</param>
        internal Margins(float top, float right, float bottom, float left) : this()
        {
            this.marginArray[(int)Direction.Top   ] = top;
            this.marginArray[(int)Direction.Right ] = right;
            this.marginArray[(int)Direction.Bottom] = bottom;
            this.marginArray[(int)Direction.Left  ] = left;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 동일 여부 구하기 - Equals(source)

        /// <summary>
        /// 동일 여부 구하기
        /// </summary>
        /// <param name="source">소스 마진</param>
        /// <returns>동일 여부</returns>
        public bool Equals(Margins source)
        {
            return (source.marginArray[(int) Direction.Bottom] == this.marginArray[(int) Direction.Bottom]) &&
                   (source.marginArray[(int) Direction.Left  ] == this.marginArray[(int) Direction.Left  ]) &&
                   (source.marginArray[(int) Direction.Right ] == this.marginArray[(int) Direction.Right ]) &&
                   (source.marginArray[(int) Direction.Top   ] == this.marginArray[(int) Direction.Top   ]);
        }

        #endregion
    }
}