using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// 
    /// </summary>
    /// <remarks>
    ///   迭 ̴̳.
    ///   ִ ܶ ̹   ֱ  RTFBlockList̴.
    /// </remarks>
    public class RTFBlockList : RTFRenderable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Field

        /// <summary>
        ///  Ʈ
        /// </summary>
        protected List<RTFBlock> blockList;

        /// <summary>
        /// Ʈ  
        /// </summary>
        protected RTFCharFormat defaultCharFormat;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///   
        /// </summary>
        private bool allowParagraph;

        /// <summary>
        ///   
        /// </summary>
        private bool allowFootnote;

        /// <summary>
        ///    
        /// </summary>
        private bool allowControlWord;

        /// <summary>
        /// ̹  
        /// </summary>
        private bool allowImage;

        /// <summary>
        /// ̺  
        /// </summary>
        private bool allowTable;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ʈ   - DefaultCharFormat

        /// <summary>
        /// Ʈ  
        /// </summary>
        public RTFCharFormat DefaultCharFormat
        {
            get
            {
                if(this.defaultCharFormat == null)
                {
                    this.defaultCharFormat = new RTFCharFormat(-1, -1, 1);
                }

                return this.defaultCharFormat;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  - RTFBlockList(allowParagraph, allowFootnote, allowControlWord, allowImage, allowTable)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="allowParagraph">  </param>
        /// <param name="allowFootnote">  </param>
        /// <param name="allowControlWord">   </param>
        /// <param name="allowImage">̹  </param>
        /// <param name="allowTable">̺  </param>
        internal RTFBlockList(bool allowParagraph, bool allowFootnote, bool allowControlWord, bool allowImage, bool allowTable)
        {
            this.blockList         = new List<RTFBlock>();
            this.defaultCharFormat = null;

            this.allowParagraph    = allowParagraph;
            this.allowFootnote     = allowFootnote;
            this.allowControlWord  = allowControlWord;
            this.allowImage        = allowImage;
            this.allowTable        = allowTable;
        }

        #endregion
        #region  - RTFBlockList(allowParagraph, allowTable)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="allowParagraph">  </param>
        /// <param name="allowTable">̺  </param>
        internal RTFBlockList(bool allowParagraph, bool allowTable) : this(allowParagraph, true, true, true, allowTable)
        {
        }

        #endregion
        #region  - RTFBlockList()

        /// <summary>
        /// 
        /// </summary>
        internal RTFBlockList() : this(true, true, true, true, true)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ߰ϱ - AddParagraph()

        /// <summary>
        ///  ߰ϱ
        /// </summary>
        /// <returns>RTF </returns>
        public RTFParagraph AddParagraph()
        {
            if(!this.allowParagraph)
            {
                throw new Exception("Paragraph is not allowed.");
            }

            RTFParagraph paragraph = new RTFParagraph(this.allowFootnote, this.allowControlWord);

            AddBlock(paragraph);

            return paragraph;
        }

        #endregion
        #region  ߰ϱ - AddSection(type, document)

        /// <summary>
        ///  ߰ϱ
        /// </summary>
        /// <param name="type"> Ÿ</param>
        /// <remarks>RTF </remarks>
        public RTFSection AddSection(SectionType type, RTFDocument document)
        {
            RTFSection section = new RTFSection(type, document);

            AddBlock(section);

            return section;
        }

        #endregion
        #region ̹ ߰ϱ - AddImage(filePath, imageFileType)

        /// <summary>
        /// ̹ ߰ϱ
        /// </summary>
        /// <param name="filePath"> </param>
        /// <param name="imageFileType">̹  Ÿ</param>
        /// <returns>RTF ̹</returns>
        public RTFImage AddImage(string filePath, ImageFileType imageFileType)
        {
            if(!this.allowImage)
            {
                throw new Exception("Image is not allowed.");
            }

            RTFImage image = new RTFImage(filePath, imageFileType);

            AddBlock(image);

            return image;
        }

        #endregion
        #region ̹ ߰ϱ - AddImage(filePath)

        /// <summary>
        /// ̹ ߰ϱ
        /// </summary>
        /// <param name="filePath"> </param>
        /// <returns>RTF ̹</returns>
        public RTFImage AddImage(string filePath)
        {
            int dotIndex = filePath.LastIndexOf(".");

            if(dotIndex < 0)
            {
                throw new Exception($"Cannot determine image type from the filename extension : {filePath}");
            }

            string fileExtension = filePath.Substring(dotIndex + 1).ToLower();

            switch(fileExtension)
            {
                case "jpg"  :
                case "jpeg" : return AddImage(filePath, ImageFileType.JPEG);
                case "gif"  : return AddImage(filePath, ImageFileType.GIF );
                case "png"  : return AddImage(filePath, ImageFileType.PNG );
                default     : throw new Exception($"Cannot determine image type from the filename extension : {filePath}");
            }
        }

        #endregion
        #region ̹ ߰ϱ - AddImage(memoryStream)

        /// <summary>
        /// ̹ ߰ϱ
        /// </summary>
        /// <param name="memoryStream">޸ Ʈ</param>
        /// <returns>RTF ̹</returns>
        public RTFImage AddImage(MemoryStream memoryStream)
        {
            if(!this.allowImage)
            {
                throw new Exception("Image is not allowed.");
            }

            RTFImage image = new RTFImage(memoryStream);

            AddBlock(image);

            return image;
        }

        #endregion
        #region ̺ ߰ϱ - AddTable(rowCount, columnCount, width, fontSize)

        /// <summary>
        /// ̺ ߰ϱ
        /// </summary>
        /// <param name="rowCount"> </param>
        /// <param name="columnCount"> </param>
        /// <param name="width">ʺ</param>
        /// <param name="fontSize">Ʈ ũ</param>
        /// <returns>RTF ̺</returns>
        public RTFTable AddTable(int rowCount, int columnCount, float width, float fontSize)
        {
            if(!this.allowTable)
            {
                throw new Exception("Table is not allowed.");
            }

            RTFTable table = new RTFTable(rowCount, columnCount, width, fontSize);

            AddBlock(table);

            return table;
        }

        #endregion

        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine();

            for(int i = 0; i < this.blockList.Count; i++)
            {
                if(this.defaultCharFormat != null && this.blockList[i].DefaultCharFormat != null)
                {
                    this.blockList[i].DefaultCharFormat.CopyFrom(this.defaultCharFormat);
                }

                stringBuilder.AppendLine(this.blockList[i].Render());
            }

            return stringBuilder.ToString();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  ϱ - TransferBlocksTo(targetBlockList)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="targetBlockList">Ÿ  Ʈ</param>
        internal void TransferBlocksTo(RTFBlockList targetBlockList)
        {
            for(int i = 0; i < this.blockList.Count; i++)
            {
                targetBlockList.AddBlock(this.blockList[i]);
            }

            this.blockList.Clear();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  ߰ϱ - AddBlock(block)

        /// <summary>
        ///  ߰ϱ
        /// </summary>
        /// <param name="block"></param>
        private void AddBlock(RTFBlock block)
        {
            if(block != null)
            {
                this.blockList.Add(block);
            }
        }

        #endregion
    }
}