using System;
using System.Collections.Generic;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF  
    /// </summary>
    public class RTFCharFormat
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ Ÿ ÷ ųʸ
        /// </summary>
        private static IDictionary<FontStyleFlag, string> _fontStyleFlagDictionary = new Dictionary<FontStyleFlag, string>
        {
            {FontStyleFlag.Bold     , "b"     },
            {FontStyleFlag.Italic   , "i"     },
            {FontStyleFlag.Scaps    , "scaps" },
            {FontStyleFlag.Strike   , "strike"},
            {FontStyleFlag.Sub      , "sub"   },
            {FontStyleFlag.Super    , "super" },
            {FontStyleFlag.Underline, "ul"    }
        };

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///  ε
        /// </summary>
        private int startIndex;

        /// <summary>
        ///  ε
        /// </summary>
        private int endIndex;

        /// <summary>
        /// Ʈ 
        /// </summary>
        private FontDescriptor fontDescriptor;

        /// <summary>
        /// ANSI Ʈ 
        /// </summary>
        private FontDescriptor ansiFontDescriptor;

        /// <summary>
        /// Ʈ ũ
        /// </summary>
        private float fontSize;

        /// <summary>
        /// Ʈ Ÿ
        /// </summary>
        private FontStyle fontStyle;

        /// <summary>
        ///   
        /// </summary>
        private ColorDescriptor backgroundColorDescriptor;

        /// <summary>
        ///   
        /// </summary>
        private ColorDescriptor foregroundColorDescriptor;

        /// <summary>
        /// ο Ÿ
        /// </summary>
        private TwoInOneStyle twoInOneStyle;

        /// <summary>
        /// ϸũ
        /// </summary>
        private string bookmark;

        /// <summary>
        ///  ۸ũ
        /// </summary>
        private string localHyperlink;

        /// <summary>
        ///  ۸ũ 
        /// </summary>
        private string localHyperlinkTip;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ʈ  - FontDescriptor

        /// <summary>
        /// Ʈ 
        /// </summary>
        public FontDescriptor FontDescriptor
        {
            get
            {
                return this.fontDescriptor;
            }
            set
            {
                this.fontDescriptor = value;
            }
        }

        #endregion
        #region ANSI Ʈ  - AnsiFontDescriptor

        /// <summary>
        /// ANSI Ʈ 
        /// </summary>
        public FontDescriptor AnsiFontDescriptor
        {
            get
            {
                return this.ansiFontDescriptor;
            }
            set
            {
                this.ansiFontDescriptor = value;
            }
        }

        #endregion
        #region Ʈ ũ - FontSize

        /// <summary>
        /// Ʈ ũ
        /// </summary>
        public float FontSize
        {
            get
            {
                return this.fontSize;
            }
            set
            {
                this.fontSize = value;
            }
        }

        #endregion
        #region Ʈ Ÿ - FontStyle

        /// <summary>
        /// Ʈ Ÿ
        /// </summary>
        public FontStyle FontStyle
        {
            get
            {
                return this.fontStyle;
            }
        }

        #endregion
        #region    - BackgroundColorDescriptor

        /// <summary>
        ///   
        /// </summary>
        public ColorDescriptor BackgroundColorDescriptor
        {
            get
            {
                return this.backgroundColorDescriptor;
            }
            set
            {
                this.backgroundColorDescriptor = value;
            }
        }

        #endregion
        #region    - ForegroundColorDescriptor

        /// <summary>
        ///   
        /// </summary>
        public ColorDescriptor ForegroundColorDescriptor
        {
            get
            {
                return this.foregroundColorDescriptor;
            }
            set
            {
                this.foregroundColorDescriptor = value;
            }
        }

        #endregion
        #region ο Ÿ - TwoInOneStyle

        /// <summary>
        /// ο Ÿ
        /// </summary>
        public TwoInOneStyle TwoInOneStyle
        {
            get
            {
                return this.twoInOneStyle;
            }
            set
            {
                this.twoInOneStyle = value;
            }
        }

        #endregion
        #region ϸũ - Bookmark

        /// <summary>
        /// ϸũ
        /// </summary>
        public string Bookmark
        {
            get
            {
                return this.bookmark;
            }
            set
            {
                this.bookmark = value;
            }
        }

        #endregion
        #region  ۸ũ - LocalHyperlink

        /// <summary>
        ///  ۸ũ
        /// </summary>
        public string LocalHyperlink
        {
            get
            {
                return this.localHyperlink;
            }
            set
            {
                this.localHyperlink = value;
            }
        }

        #endregion
        #region  ۸ũ  - LocalHyperlinkTip

        /// <summary>
        ///  ۸ũ 
        /// </summary>
        public string LocalHyperlinkTip
        {
            get
            {
                return this.localHyperlinkTip;
            }
            set
            {
                this.localHyperlinkTip = value;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  ε - StartIndex

        /// <summary>
        ///  ε
        /// </summary>
        internal int StartIndex
        {
            get
            {
                return this.startIndex;
            }
        }

        #endregion
        #region  ε - EndIndex

        /// <summary>
        ///  ε
        /// </summary>
        internal int EndIndex
        {
            get
            {
                return this.endIndex;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  - RTFCharFormat(startIndex, endIndex, textLength)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="startIndex"> ε</param>
        /// <param name="endIndex"> ε</param>
        /// <param name="textLength">ؽƮ </param>
        internal RTFCharFormat(int startIndex, int endIndex, int textLength)
        {
            this.startIndex                = -1;
            this.endIndex                  = -1;
            this.fontDescriptor            = null;
            this.ansiFontDescriptor        = null;
            this.fontSize                  = -1;
            this.fontStyle                 = new FontStyle();
            this.backgroundColorDescriptor = null;
            this.foregroundColorDescriptor = null;
            this.twoInOneStyle             = TwoInOneStyle.Disabled;
            this.bookmark                  = string.Empty;

            SetRange(startIndex, endIndex, textLength);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region ϱ - CopyFrom(format)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="format">RTF  </param>
        internal void CopyFrom(RTFCharFormat format)
        {
            if(format == null)
            {
                return;
            }

            this.startIndex = format.startIndex;
            this.endIndex   = format.endIndex;

            if(this.fontDescriptor == null && format.fontDescriptor != null)
            {
                this.fontDescriptor = new FontDescriptor(format.fontDescriptor.Value);
            }

            if(this.ansiFontDescriptor == null && format.ansiFontDescriptor != null)
            {
                this.ansiFontDescriptor = new FontDescriptor(format.ansiFontDescriptor.Value);
            }

            if(this.fontSize < 0 && format.fontSize >= 0)
            {
                this.fontSize = format.fontSize;
            }

            if(this.fontStyle.IsEmpty && !format.fontStyle.IsEmpty)
            {
                this.fontStyle = new FontStyle(format.fontStyle);
            }

            if(this.backgroundColorDescriptor == null && format.backgroundColorDescriptor != null)
            {
                this.backgroundColorDescriptor = new ColorDescriptor(format.backgroundColorDescriptor.Value);
            }

            if(this.foregroundColorDescriptor == null && format.foregroundColorDescriptor != null)
            {
                this.foregroundColorDescriptor = new ColorDescriptor(format.foregroundColorDescriptor.Value);
            }
        }

        #endregion

        #region  ϱ - RenderHead()

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <returns> RTF ڿ</returns>
        internal string RenderHead()
        {
            StringBuilder stringBuilder = new StringBuilder("{");

            if(!string.IsNullOrEmpty(this.localHyperlink))
            {
                stringBuilder.Append(@"{\field{\*\fldinst HYPERLINK \\l ");

                stringBuilder.Append("\"" + this.localHyperlink + "\"");

                if(!string.IsNullOrEmpty(this.localHyperlinkTip))
                {
                    stringBuilder.Append(" \\\\o \"" + this.localHyperlinkTip + "\"");
                }

                stringBuilder.Append(@"}{\fldrslt{");
            }

            if(this.fontDescriptor != null || this.ansiFontDescriptor != null)
            {
                if(this.fontDescriptor == null)
                {
                    stringBuilder.Append(@"\f" + this.ansiFontDescriptor.Value);
                }
                else if(this.ansiFontDescriptor == null)
                {
                    stringBuilder.Append(@"\f" + this.fontDescriptor.Value);
                }
                else
                {
                    stringBuilder.Append
                    (
                        @"\loch\af"                                 +
                        this.ansiFontDescriptor.Value + @"\hich\af" +
                        this.ansiFontDescriptor.Value + @"\dbch\af" +
                        this.fontDescriptor.Value
                    );
                }
            }

            if(this.fontSize > 0)
            {
                stringBuilder.Append(@"\fs" + RTFUtility.DoubleValue(this.fontSize));
            }

            if(this.foregroundColorDescriptor != null)
            {
                stringBuilder.Append(@"\cf" + this.foregroundColorDescriptor.Value);
            }

            if(this.backgroundColorDescriptor != null)
            {
                stringBuilder.Append
                (
                    @"\chshdng0\chcbpat"                 +
                    this.backgroundColorDescriptor.Value +
                    @"\cb"                               +
                    this.backgroundColorDescriptor.Value
                );
            }

            foreach(KeyValuePair<FontStyleFlag, string> keyValuePair in _fontStyleFlagDictionary)
            {
                if(FontStyle.ContainsStyleToAdd(keyValuePair.Key))
                {
                    stringBuilder.Append(@"\" + keyValuePair.Value);
                }
                else if(FontStyle.ContainsStyleToRemove(keyValuePair.Key))
                {
                    stringBuilder.Append(@"\" + keyValuePair.Value + "0");
                }
            }

            if(this.twoInOneStyle != TwoInOneStyle.Disabled)
            {
                stringBuilder.Append(@"\twoinone");

                switch(this.twoInOneStyle)
                {
                    case TwoInOneStyle.None           : stringBuilder.Append("0"); break;
                    case TwoInOneStyle.Parentheses    : stringBuilder.Append("1"); break;
                    case TwoInOneStyle.SquareBrackets : stringBuilder.Append("2"); break;
                    case TwoInOneStyle.AngledBrackets : stringBuilder.Append("3"); break;
                    case TwoInOneStyle.Braces         : stringBuilder.Append("4"); break;
                }
            }

            if(stringBuilder.ToString().Contains(@"\"))
            {
                stringBuilder.Append(" ");
            }

            if(!string.IsNullOrEmpty(this.bookmark))
            {
                stringBuilder.Append(@"{\*\bkmkstart " + this.bookmark + "}");
            }

            return stringBuilder.ToString();
        }

        #endregion
        #region  ϱ - RenderTail()

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <returns> RTF ڿ</returns>
        internal string RenderTail()
        {
            StringBuilder stringBuilder = new StringBuilder("");

            if(!string.IsNullOrEmpty(this.bookmark))
            {
                stringBuilder.Append(@"{\*\bkmkend " + this.bookmark + "}");
            }

            if(!string.IsNullOrEmpty(this.localHyperlink))
            {
                stringBuilder.Append(@"}}}");
            }

            stringBuilder.Append("}");

            return stringBuilder.ToString();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  ϱ - SetRange(startIndex, endIndex, textLength)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="startIndex"> ε</param>
        /// <param name="endIndex"> ε</param>
        /// <param name="textLength">ؽƮ </param>
        private void SetRange(int startIndex, int endIndex, int textLength)
        {
            if(startIndex > endIndex)
            {
                throw new Exception($"Invalid range : ({startIndex}, {endIndex})");
            }
            else if(startIndex < 0 || endIndex < 0)
            {
                if(startIndex != -1 || endIndex != -1)
                {
                    throw new Exception($"Invalid range : ({startIndex}, {endIndex})");
                }
            }

            if(endIndex >= textLength)
            {
                throw new Exception($"Range ending out of range : {endIndex}");
            }

            this.startIndex = startIndex;
            this.endIndex   = endIndex;
        }

        #endregion
    }
}