namespace TestLibrary
{
    /// <summary>
    /// RTF ʵ  
    /// </summary>
    public class RTFFieldControlWord : RTFRenderable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Enumeration
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ʵ Ÿ - FieldType

        /// <summary>
        /// ʵ Ÿ
        /// </summary>
        public enum FieldType
        {
            /// <summary>
            /// ش 
            /// </summary>
            None = 0,

            /// <summary>
            ///  ȣ
            /// </summary>
            PageNumber,

            /// <summary>
            ///  
            /// </summary>
            PageCount,

            /// <summary>
            /// ¥
            /// </summary>
            Date,

            /// <summary>
            /// ð
            /// </summary>
            Time,
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///   Ʈ
        /// </summary>
        private static string[] _controlWordList = new string[]
        {
            "",
            @"{\field{\*\fldinst PAGE }}",
            @"{\field{\*\fldinst NUMPAGES }}",
            @"{\field{\*\fldinst DATE }}",
            @"{\field{\*\fldinst TIME }}"
        };

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ġ
        /// </summary>
        private int position;

        /// <summary>
        /// ʵ Ÿ
        /// </summary>
        private FieldType fieldType;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region ġ - Position

        /// <summary>
        /// ġ
        /// </summary>
        internal int Position
        {
            get
            {
                return this.position;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  - RTFFieldControlWord(position, fieldType)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="position">ġ</param>
        /// <param name="fieldType">ʵ Ÿ</param>
        internal RTFFieldControlWord(int position, FieldType fieldType)
        {
            this.position  = position;
            this.fieldType = fieldType;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            return _controlWordList[(int)this.fieldType];
        }

        #endregion
    }
}