using System;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF 
    /// </summary>
    public class RTFFootnote : RTFBlockList
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ġ
        /// </summary>
        private int position;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region ġ - Position

        /// <summary>
        /// ġ
        /// </summary>
        internal int Position
        {
            get
            {
                return this.position;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFFootnote(position, textLength)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="position">ġ</param>
        /// <param name="textLength">ؽƮ </param>
        internal RTFFootnote(int position, int textLength) : base(true, false, false, true, false)
        {
            if(position < 0 || position >= textLength)
            {
                throw new Exception($"Invalid footnote position : {position} (text length={textLength})");
            }

            this.position = position;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine(@"{\super\chftn}");

            stringBuilder.AppendLine(@"{\footnote\plain\chftn");

            base.blockList[base.blockList.Count - 1].BlockTail = "}";

            stringBuilder.Append(base.Render());

            stringBuilder.AppendLine("}");

            return stringBuilder.ToString();
        }

        #endregion
    }
}