using System;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF /ٴڱ
    /// </summary>
    public class RTFHeaderFooter : RTFBlockList
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// /ٴڱ Ÿ
        /// </summary>
        private HeaderFooterType type;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  - RTFHeaderFooter(type)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="type">/ٴڱ Ÿ</param>
        internal RTFHeaderFooter(HeaderFooterType type) : base(true, false, true, true, false)
        {
            this.type = type;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            StringBuilder stringBuilder = new StringBuilder();

            if(this.type == HeaderFooterType.Header)
            {
                stringBuilder.AppendLine(@"{\header");
            }
            else if(this.type == HeaderFooterType.Footer)
            {
                stringBuilder.AppendLine(@"{\footer");
            }
            else
            {
                throw new Exception("Invalid HeaderFooterType");
            }

            stringBuilder.AppendLine();

            for(int i = 0; i < base.blockList.Count; i++)
            {
                if(base.defaultCharFormat != null && (base.blockList[i]).DefaultCharFormat != null)
                {
                    base.blockList[i].DefaultCharFormat.CopyFrom(base.defaultCharFormat);
                }

                stringBuilder.AppendLine((blockList[i]).Render());
            }

            stringBuilder.AppendLine("}");

            return stringBuilder.ToString();
        }

        #endregion
    }
}