using System;
using System.Collections.Generic;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF 
    /// </summary>
    public class RTFParagraph : RTFBlock
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Class
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region и  - DisjointRange

        /// <summary>
        /// и 
        /// </summary>
        private class DisjointRange
        {
            //////////////////////////////////////////////////////////////////////////////////////////////////// Field
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region Field

            /// <summary>
            /// 
            /// </summary>
            public int Head;

            /// <summary>
            /// 
            /// </summary>
            public int Tail;

            /// <summary>
            ///  
            /// </summary>
            public RTFCharFormat CharFormat;

            #endregion

            //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region  - DisjointRange()

            /// <summary>
            /// 
            /// </summary>
            public DisjointRange()
            {
                Head = -1;
                Tail = -1;
                CharFormat = null;
            }

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Structure
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ū - Token

        /// <summary>
        /// ū
        /// </summary>
        protected struct Token
        {
            //////////////////////////////////////////////////////////////////////////////////////////////////// Field
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region Field

            /// <summary>
            /// ؽƮ
            /// </summary>
            public string Text;

            /// <summary>
            ///  
            /// </summary>
            public bool IsControl;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Field

        /// <summary>
        ///    
        /// </summary>
        protected bool allowControlWord;

        /// <summary>
        ///   
        /// </summary>
        protected bool allowFootnote;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///  
        /// </summary>
        private HorizontalAlignment horizontalAlignment;

        /// <summary>
        /// 
        /// </summary>
        private Margins margins;

        /// <summary>
        /// ڿ 
        /// </summary>
        private StringBuilder stringBuilder;

        /// <summary>
        ///  
        /// </summary>
        private float lineSpacing;

        /// <summary>
        ///  
        /// </summary>
        private string blockHead;

        /// <summary>
        ///  
        /// </summary>
        private string blockTail;

        /// <summary>
        ///    
        /// </summary>
        private bool startNewPage;

        /// <summary>
        /// ù°  鿩
        /// </summary>
        private float firstLineIndent;

        /// <summary>
        ///   Ʈ
        /// </summary>
        private List<RTFCharFormat> charFormatList;

        /// <summary>
        /// Ʈ  
        /// </summary>
        private RTFCharFormat defaultCharFormat;

        /// <summary>
        /// ʵ   Ʈ
        /// </summary>
        private List<RTFFieldControlWord> fieldControlWordList;

        /// <summary>
        ///  Ʈ
        /// </summary>
        private List<RTFFootnote> footnoteList;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   - HorizontalAlignment

        /// <summary>
        ///  
        /// </summary>
        public override HorizontalAlignment HorizontalAlignment
        {
            get
            {
                return this.horizontalAlignment;
            }
            set
            {
                this.horizontalAlignment = value;
            }
        }

        #endregion
        #region  - Margins

        /// <summary>
        /// 
        /// </summary>
        public override Margins Margins
        {
            get
            {
                return this.margins;
            }
        }

        #endregion
        #region ڿ  - StringBuilder

        /// <summary>
        /// ڿ 
        /// </summary>
        public StringBuilder StringBuilder
        {
            get
            {
                return this.stringBuilder;
            }
        }

        #endregion
        #region   - LineSpacing

        /// <summary>
        ///  
        /// </summary>
        public float LineSpacing
        {
            get
            {
                return this.lineSpacing;
            }
            set
            {
                this.lineSpacing = value;
            }
        }

        #endregion
        #region     - StartNewPage

        /// <summary>
        ///    
        /// </summary>
        public override bool StartNewPage
        {
            get
            {
                return this.startNewPage;
            }
            set
            {
                this.startNewPage = value;
            }
        }

        #endregion
        #region ù°  鿩 - FirstLineIndent

        /// <summary>
        /// ù°  鿩
        /// </summary>
        public float FirstLineIndent
        {
            get
            {
                return this.firstLineIndent;
            }
            set
            {
                this.firstLineIndent = value;
            }
        }

        #endregion
        #region Ʈ   - DefaultCharFormat

        /// <summary>
        /// Ʈ  
        /// </summary>
        public override RTFCharFormat DefaultCharFormat
        {
            get
            {
                if(this.defaultCharFormat == null)
                {
                    this.defaultCharFormat = new RTFCharFormat(-1, -1, this.stringBuilder.Length);
                }

                return this.defaultCharFormat;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region   - BlockHead

        /// <summary>
        ///  
        /// </summary>
        internal override string BlockHead
        {
            set
            {
                this.blockHead = value;
            }
        }

        #endregion
        #region   - BlockTail

        /// <summary>
        ///  
        /// </summary>
        internal override string BlockTail
        {
            set
            {
                this.blockTail = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFParagraph(allowFootnote, allowControlWord)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="allowFootnote">  </param>
        /// <param name="allowControlWord">   </param>
        public RTFParagraph(bool allowFootnote, bool allowControlWord)
        {
            this.stringBuilder        = new StringBuilder();
            this.lineSpacing          = -1;
            this.margins              = new Margins();
            this.horizontalAlignment  = HorizontalAlignment.Left;
            this.charFormatList       = new List<RTFCharFormat>();
            this.allowFootnote        = allowFootnote;
            this.allowControlWord     = allowControlWord;
            this.footnoteList         = new List<RTFFootnote>();
            this.fieldControlWordList = new List<RTFFieldControlWord>();
            this.blockHead            = @"{\pard";
            this.blockTail            = @"\par}";
            this.startNewPage         = false;
            this.firstLineIndent      = 0;
            this.defaultCharFormat    = null;
        }

        #endregion
        #region  - RTFParagraph()

        /// <summary>
        /// 
        /// </summary>
        public RTFParagraph() : this(false, false)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ؽƮ ϱ - SetText(text)

        /// <summary>
        /// ؽƮ ϱ
        /// </summary>
        /// <param name="text">ؽƮ</param>
        public void SetText(string text)
        {
            this.stringBuilder = new StringBuilder(text);
        }

        #endregion
        #region   ߰ϱ - AddCharFormat(startIndex, endIndex)

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <param name="startIndex"> ε</param>
        /// <param name="endIndex"> ε</param>
        /// <returns>RTF  </returns>
        public RTFCharFormat AddCharFormat(int startIndex, int endIndex)
        {
            RTFCharFormat format = new RTFCharFormat(startIndex, endIndex, this.stringBuilder.Length);

            this.charFormatList.Add(format);

            return format;
        }

        #endregion
        #region   ߰ϱ - AddCharFormat()

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <returns>RTF  </returns>
        public RTFCharFormat AddCharFormat()
        {
            return AddCharFormat(-1, -1);
        }

        #endregion
        #region  ߰ϱ - AddFootnote(position)

        /// <summary>
        ///  ߰ϱ
        /// </summary>
        /// <param name="position">ġ</param>
        /// <returns>RTF </returns>
        public RTFFootnote AddFootnote(int position)
        {
            if(!this.allowFootnote)
            {
                throw new Exception("Footnote is not allowed.");
            }

            RTFFootnote footnote = new RTFFootnote(position, this.stringBuilder.Length);

            this.footnoteList.Add(footnote);

            return footnote;
        }

        #endregion
        #region   ߰ϱ - AddControlWord(position, type)

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <param name="position">ġ</param>
        /// <param name="type">ʵ Ÿ</param>
        public void AddControlWord(int position, RTFFieldControlWord.FieldType type)
        {
            if(!this.allowControlWord)
            {
                throw new Exception("ControlWord is not allowed.");
            }

            RTFFieldControlWord fieldControlWord = new RTFFieldControlWord(position, type);

            for(int i = 0; i < this.fieldControlWordList.Count; i++)
            {
                if(this.fieldControlWordList[i].Position == fieldControlWord.Position)
                {
                    this.fieldControlWordList[i] = fieldControlWord;

                    return;
                }
            }

            this.fieldControlWordList.Add(fieldControlWord);
        }

        #endregion
        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            LinkedList<Token> tokenList = BuildTokenList();

            StringBuilder stringBuilder = new StringBuilder(this.blockHead);

            if(this.startNewPage)
            {
                stringBuilder.Append(@"\pagebb");
            }

            if(this.lineSpacing >= 0)
            {
                stringBuilder.Append(@"\sl-" + RTFUtility.ConvertPointToTwip(this.lineSpacing) + @"\slmult0");
            }

            if(this.margins[Direction.Top] > 0)
            {
                stringBuilder.Append(@"\sb" + RTFUtility.ConvertPointToTwip(this.margins[Direction.Top]));
            }

            if(this.margins[Direction.Bottom] > 0)
            {
                stringBuilder.Append(@"\sa" + RTFUtility.ConvertPointToTwip(this.margins[Direction.Bottom]));
            }

            if(this.margins[Direction.Left] > 0)
            {
                stringBuilder.Append(@"\li" + RTFUtility.ConvertPointToTwip(this.margins[Direction.Left]));
            }

            if(this.margins[Direction.Right] > 0)
            {
                stringBuilder.Append(@"\ri" + RTFUtility.ConvertPointToTwip(this.margins[Direction.Right]));
            }

            stringBuilder.Append(@"\fi" + RTFUtility.ConvertPointToTwip(this.firstLineIndent));

            stringBuilder.Append(GetAlignmentCode());

            stringBuilder.AppendLine();

            if(this.defaultCharFormat != null)
            {
                stringBuilder.AppendLine(this.defaultCharFormat.RenderHead());
            }

            stringBuilder.AppendLine(ExtractTokenList(tokenList));

            if(this.defaultCharFormat != null)
            {
                stringBuilder.Append(this.defaultCharFormat.RenderTail());
            }

            stringBuilder.AppendLine(this.blockTail);

            return stringBuilder.ToString();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ū Ʈ ϱ - BuildTokenList()

        /// <summary>
        /// ū Ʈ ϱ
        /// </summary>
        /// <returns>ū Ʈ</returns>
        protected LinkedList<Token> BuildTokenList()
        {
            int                   count;
            Token                 token;
            LinkedList<Token>     tokenList = new LinkedList<Token>();
            LinkedListNode<Token> tokenNode;
            List<DisjointRange>   disjoinRangeList = new List<DisjointRange>();

            #region ߿   ֵ    []  [] Ѵ.

            for(int i = 0; i < this.charFormatList.Count; i++)
            {
                RTFCharFormat format = this.charFormatList[i];

                DisjointRange range = null;

                if(format.StartIndex == -1 && format.EndIndex == -1)
                {
                    range = new DisjointRange();

                    range.Head       = 0;
                    range.Tail       = this.stringBuilder.Length - 1;
                    range.CharFormat = format;
                }
                else if(format.StartIndex <= format.EndIndex)
                {
                    range = new DisjointRange();

                    range.Head       = format.StartIndex;
                    range.Tail       = format.EndIndex;
                    range.CharFormat = format;
                }
                else
                {
                    continue;
                }

                if(range.Tail >= this.stringBuilder.Length)
                {
                    range.Tail = this.stringBuilder.Length - 1;

                    if(range.Head > range.Tail)
                    {
                        continue;
                    }
                }

                List<DisjointRange> deletList     = new List<DisjointRange>();
                List<DisjointRange> addList       = new List<DisjointRange>();
                List<DisjointRange> addAnchorList = new List<DisjointRange>();

                for(int j = 0; j < disjoinRangeList.Count; j++)
                {
                    DisjointRange temporaryRange = disjoinRangeList[j];

                    if(range.Head <= temporaryRange.Head && range.Tail >= temporaryRange.Tail)
                    {
                        deletList.Add(temporaryRange);
                    }
                    else if(range.Head <= temporaryRange.Head && range.Tail >= temporaryRange.Head && range.Tail < temporaryRange.Tail)
                    {
                        temporaryRange.Head = range.Tail + 1;
                    }
                    else if(range.Head > temporaryRange.Head && range.Head <= temporaryRange.Tail && range.Tail >= temporaryRange.Tail)
                    {
                        temporaryRange.Tail = range.Head - 1;
                    }
                    else if(range.Head > temporaryRange.Head && range.Tail < temporaryRange.Tail)
                    {
                        DisjointRange newRange = new DisjointRange();

                        newRange.Head       = range.Tail + 1;
                        newRange.Tail       = temporaryRange.Tail;
                        newRange.CharFormat = temporaryRange.CharFormat;

                        temporaryRange.Tail = range.Head - 1;

                        addList.Add(newRange);

                        addAnchorList.Add(temporaryRange);
                    }
                }

                disjoinRangeList.Add(range);

                for(int j = 0; j < deletList.Count; j++)
                {
                    disjoinRangeList.Remove(deletList[j]);
                }

                for(int j = 0; j < addList.Count; j++)
                {
                    int index = disjoinRangeList.IndexOf(addAnchorList[j]);

                    if(index < 0)
                    {
                        continue;
                    }

                    disjoinRangeList.Insert(index, addList[j]);
                }
            }

            #endregion

            token = new Token();

            token.Text      = this.stringBuilder.ToString();
            token.IsControl = false;

            tokenList.AddLast(token);

            #region []  [] ū Ʈ Ѵ.

            for(int i = 0; i < disjoinRangeList.Count; i++)
            {
                DisjointRange range = disjoinRangeList[i];

                count = 0;

                if(range.Head == 0)
                {
                    Token newToken = new Token();

                    newToken.IsControl = true;
                    newToken.Text      = range.CharFormat.RenderHead();

                    tokenList.AddFirst(newToken);
                }
                else
                {
                    tokenNode = tokenList.First;

                    while(tokenNode != null)
                    {
                        Token temporaryToken = tokenNode.Value;

                        if(!temporaryToken.IsControl)
                        {
                            count += temporaryToken.Text.Length;

                            if(count == range.Head)
                            {
                                Token newToken = new Token();

                                newToken.IsControl = true;
                                newToken.Text      = range.CharFormat.RenderHead();

                                while(tokenNode.Next != null && tokenNode.Next.Value.IsControl)
                                {
                                    tokenNode = tokenNode.Next;
                                }

                                tokenList.AddAfter(tokenNode, newToken);

                                break;
                            }
                            else if(count > range.Head)
                            {
                                LinkedListNode<Token> newTokenNode;

                                Token newToken1 = new Token();

                                newToken1.IsControl = false;
                                newToken1.Text      = temporaryToken.Text.Substring(0, temporaryToken.Text.Length - (count - range.Head));

                                newTokenNode = tokenList.AddAfter(tokenNode, newToken1);

                                Token newToken2 = new Token();

                                newToken2.IsControl = true;
                                newToken2.Text      = range.CharFormat.RenderHead();

                                newTokenNode = tokenList.AddAfter(newTokenNode, newToken2);

                                Token newToken3 = new Token();

                                newToken3.IsControl = false;
                                newToken3.Text      = temporaryToken.Text.Substring(temporaryToken.Text.Length - (count - range.Head));

                                newTokenNode = tokenList.AddAfter(newTokenNode, newToken3);

                                tokenList.Remove(tokenNode);

                                break;
                            }
                        }

                        tokenNode = tokenNode.Next;
                    }
                }

                count     = 0;
                tokenNode = tokenList.First;

                while(tokenNode != null)
                {
                    Token temporaryToken = tokenNode.Value;

                    if(!temporaryToken.IsControl)
                    {
                        count += temporaryToken.Text.Length;

                        if(count - 1 == range.Tail)
                        {
                            Token newToken = new Token();

                            newToken.IsControl = true;
                            newToken.Text      = range.CharFormat.RenderTail();

                            tokenList.AddAfter(tokenNode, newToken);

                            break;
                        }
                        else if(count - 1 > range.Tail)
                        {
                            LinkedListNode<Token> newTokenNode;

                            Token newToken1 = new Token();

                            newToken1.IsControl = false;
                            newToken1.Text      = temporaryToken.Text.Substring(0, temporaryToken.Text.Length - (count - range.Tail) + 1);

                            newTokenNode = tokenList.AddAfter(tokenNode, newToken1);

                            Token newToken2 = new Token();

                            newToken2.IsControl = true;
                            newToken2.Text      = range.CharFormat.RenderTail();

                            newTokenNode = tokenList.AddAfter(newTokenNode, newToken2);

                            Token newToken3 = new Token();

                            newToken3.IsControl = false;
                            newToken3.Text      = temporaryToken.Text.Substring(temporaryToken.Text.Length - (count - range.Tail) + 1);

                            newTokenNode = tokenList.AddAfter(newTokenNode, newToken3);

                            tokenList.Remove(tokenNode);

                            break;
                        }
                    }

                    tokenNode = tokenNode.Next;
                }
            }

            #endregion
            #region ū Ʈ ָ Ѵ.

            for(int i = 0; i < this.footnoteList.Count; i++)
            {
                int position = this.footnoteList[i].Position;

                if(position >= this.stringBuilder.Length)
                {
                    continue;
                }
                
                count     = 0;
                tokenNode = tokenList.First;

                while(tokenNode != null)
                {
                    Token temporaryToken = tokenNode.Value;

                    if(!temporaryToken.IsControl)
                    {
                        count += temporaryToken.Text.Length;

                        if(count - 1 == position)
                        {
                            Token newToken = new Token();

                            newToken.IsControl = true;
                            newToken.Text      = this.footnoteList[i].Render();

                            tokenList.AddAfter(tokenNode, newToken);

                            break;
                        }
                        else if(count - 1 > position)
                        {
                            LinkedListNode<Token> newTokenNode;

                            Token newToken1 = new Token();

                            newToken1.IsControl = false;
                            newToken1.Text      = temporaryToken.Text.Substring(0, temporaryToken.Text.Length - (count - position) + 1);

                            newTokenNode = tokenList.AddAfter(tokenNode, newToken1);

                            Token newToken2 = new Token();

                            newToken2.IsControl = true;
                            newToken2.Text      = this.footnoteList[i].Render();

                            newTokenNode = tokenList.AddAfter(newTokenNode, newToken2);

                            Token newToken3 = new Token();

                            newToken3.IsControl = false;
                            newToken3.Text      = temporaryToken.Text.Substring(temporaryToken.Text.Length - (count - position) + 1);

                            newTokenNode = tokenList.AddAfter(newTokenNode, newToken3);

                            tokenList.Remove(tokenNode);

                            break;
                        }
                    }

                    tokenNode = tokenNode.Next;
                }
            }

            #endregion
            #region ū Ʈ  ڸ Ѵ.

            for(int i = 0; i < this.fieldControlWordList.Count; i++)
            {
                int position = this.fieldControlWordList[i].Position;

                if(position >= this.stringBuilder.Length)
                {
                    continue;
                }

                count     = 0;
                tokenNode = tokenList.First;

                while(tokenNode != null)
                {
                    Token temporaryToken = tokenNode.Value;

                    if(!temporaryToken.IsControl)
                    {
                        count += temporaryToken.Text.Length;

                        if(count - 1 == position)
                        {
                            Token newToken = new Token();

                            newToken.IsControl = true;
                            newToken.Text      = this.fieldControlWordList[i].Render();

                            tokenList.AddAfter(tokenNode, newToken);

                            break;
                        }
                        else if(count - 1 > position)
                        {
                            LinkedListNode<Token> newTokenNode;

                            Token newToken1 = new Token();

                            newToken1.IsControl = false;
                            newToken1.Text      = temporaryToken.Text.Substring(0, temporaryToken.Text.Length - (count - position) + 1);

                            newTokenNode = tokenList.AddAfter(tokenNode, newToken1);

                            Token newToken2 = new Token();

                            newToken2.IsControl = true;
                            newToken2.Text      = this.fieldControlWordList[i].Render();

                            newTokenNode = tokenList.AddAfter(newTokenNode, newToken2);

                            Token newToken3 = new Token();

                            newToken3.IsControl = false;
                            newToken3.Text      = temporaryToken.Text.Substring(temporaryToken.Text.Length - (count - position) + 1);

                            newTokenNode = tokenList.AddAfter(newTokenNode, newToken3);

                            tokenList.Remove(tokenNode);

                            break;
                        }
                    }

                    tokenNode = tokenNode.Next;
                }
            }

            #endregion

            return tokenList;
        }

        #endregion
        #region ū Ʈ ϱ - ExtractTokenList(tokenList)

        /// <summary>
        /// ū Ʈ ϱ
        /// </summary>
        /// <param name="tokenList">ū Ʈ</param>
        /// <returns>RTF ڿ</returns>
        protected string ExtractTokenList(LinkedList<Token> tokenList)
        {
            LinkedListNode<Token> tokenNode;

            StringBuilder stringBuilder = new StringBuilder();

            tokenNode = tokenList.First;

            while(tokenNode != null)
            {
                if(tokenNode.Value.IsControl)
                {
                    stringBuilder.Append(tokenNode.Value.Text);
                }
                else
                {
                    stringBuilder.Append(RTFUtility.ConvertToUnicodeEncoding(tokenNode.Value.Text));
                }

                tokenNode = tokenNode.Next;
            }

            return stringBuilder.ToString();
        }

        #endregion
    }
}