using System;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF 
    /// </summary>
    public class RTFSection : RTFBlock
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///  
        /// </summary>
        private HorizontalAlignment horizontalAlignment;

        /// <summary>
        /// 
        /// </summary>
        private readonly Margins margins;

        /// <summary>
        ///  ٴڱ
        /// </summary>
        private RTFSectionFooter sectionFooter;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   - HorizontalAlignment

        /// <summary>
        ///  
        /// </summary>
        public override HorizontalAlignment HorizontalAlignment
        {
            get
            {
                return this.horizontalAlignment;
            }
            set
            {
                this.horizontalAlignment = value;
            }
        }

        #endregion
        #region  - Margins

        /// <summary>
        /// 
        /// </summary>
        public override Margins Margins
        {
            get
            {
                return this.margins;
            }
        }

        #endregion
        #region     - StartNewPage

        /// <summary>
        ///    
        /// </summary>
        public override bool StartNewPage { get; set; }

        #endregion
        #region   - PaperOrientation

        /// <summary>
        ///  
        /// </summary>
        public PaperOrientation PaperOrientation { get; set; }

        #endregion
        #region  ʺ - PageWidth

        /// <summary>
        ///  ʺ
        /// </summary>
        public int PageWidth { get; set; }

        #endregion
        #region   - PageHeight

        /// <summary>
        ///  
        /// </summary>
        public int PageHeight { get; set; }

        #endregion
        #region  Ÿ - SectionType

        /// <summary>
        ///  Ÿ
        /// </summary>
        public SectionType SectionType { get; private set; }

        #endregion
        #region  ٴڱ - SectionFooter

        /// <summary>
        ///  ٴڱ
        /// </summary>
        public RTFSectionFooter SectionFooter
        {
            get
            {
                return this.sectionFooter ?? (this.sectionFooter = new RTFSectionFooter(this));
            }
        }

        #endregion
        #region Ʈ   - DefaultCharFormat

        /// <summary>
        /// Ʈ  
        /// </summary>
        public override RTFCharFormat DefaultCharFormat
        {
            get
            {
                throw new Exception("BlockHead is not supported for sections.");
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region   - BlockHead

        /// <summary>
        ///  
        /// </summary>
        internal override string BlockHead
        {
            set
            {
                throw new Exception("BlockHead is not supported for sections.");
            }
        }

        #endregion
        #region   - BlockTail

        /// <summary>
        ///  
        /// </summary>
        internal override string BlockTail
        {
            set
            {
                throw new Exception("BlockHead is not supported for sections.");
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region θ  - ParentDocument

        /// <summary>
        /// θ 
        /// </summary>
        private RTFDocument ParentDocument { get; set; }

        #endregion
        #region  Ʒʿ ٴڱ ġ - FooterPositionFromPageBottom

        /// <summary>
        ///  Ʒʿ ٴڱ ġ
        /// </summary>
        private int FooterPositionFromPageBottom { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  - RTFSection(sectionType, document)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sectionType"> Ÿ</param>
        /// <param name="document">RTF </param>
        internal RTFSection(SectionType sectionType, RTFDocument document)
        {
            ParentDocument = document;

            this.horizontalAlignment = HorizontalAlignment.None;

            PaperOrientation             = PaperOrientation.Portrait;
            SectionType                  = sectionType;
            FooterPositionFromPageBottom = 720;

            this.sectionFooter = null;

            this.margins = new Margins();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            StringBuilder stringBuilder = new StringBuilder();

            if(SectionType == SectionType.Start)
            {
                stringBuilder.AppendLine
                (
                    string.Format
                    (
                        @"{{\sectd\ltrsect\footery{0}\sectdefaultcl\sftnbj{1} ",
                        FooterPositionFromPageBottom,
                        GetAlignmentCode()
                    )
                );

                if(PaperOrientation == PaperOrientation.Landscape)
                {
                    stringBuilder.Append(@"\lndscpsxn ");
                }

                stringBuilder.Append(string.Format(@"\pgwsxn{0}\pghsxn{1} ",PageWidth, PageHeight));

                if(!ParentDocument.Margins.Equals((object)Margins))
                {
                    stringBuilder.Append
                    (
                        string.Format
                        (
                            @"\marglsxn{0}\margrsxn{1}\margtsxn{2}\margbsxn{3} ",
                            Margins[Direction.Left],
                            Margins[Direction.Right],
                            Margins[Direction.Top],
                            Margins[Direction.Bottom]
                        )
                    );
                }

                if(SectionFooter != null)
                {
                    stringBuilder.AppendLine(SectionFooter.Render());
                }
            }
            else
            {
                stringBuilder.AppendLine(string.Format(@"\sect }}"));
            }

            return stringBuilder.ToString();
        }

        #endregion
    }
}