using System;
using System.Collections.Generic;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF ̺
    /// </summary>
    public class RTFTable : RTFBlock
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///    
        /// </summary>
        private bool startNewPage;

        /// <summary>
        ///  
        /// </summary>
        private HorizontalAlignment horizontalAlignment;

        /// <summary>
        /// 
        /// </summary>
        private Margins margins;

        /// <summary>
        ///  
        /// </summary>
        private int rowCount;

        /// <summary>
        ///  
        /// </summary>
        private int columnCount;

        /// <summary>
        ///   迭
        /// </summary>
        private float[] rowHeightArray;

        /// <summary>
        ///  е 迭
        /// </summary>
        private Margins[] cellPaddingArray;

        /// <summary>
        /// Ʈ  ʺ
        /// </summary>
        private float defaultCellWidth;

        /// <summary>
        ///  迭
        /// </summary>
        private RTFTableCell[][] cellArray;

        /// <summary>
        /// ǥ  Ʈ
        /// </summary>
        private List<RTFTableCell> representativeCellList;

        /// <summary>
        ///       迭
        /// </summary>
        private bool[] rowKeepInSamePageArray;

        /// <summary>
        ///   
        /// </summary>
        private int titleRowCount;

        /// <summary>
        /// Ʈ ũ
        /// </summary>
        private readonly float fontSize;

        /// <summary>
        /// Ʈ  
        /// </summary>
        private RTFCharFormat defaultCharFormat;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region     - StartNewPage

        /// <summary>
        ///    
        /// </summary>
        public override bool StartNewPage
        {
            get
            {
                return this.startNewPage;
            }
            set
            {
                this.startNewPage = value;
            }
        }

        #endregion
        #region   - HorizontalAlignment

        /// <summary>
        ///  
        /// </summary>
        public override HorizontalAlignment HorizontalAlignment
        {
            get
            {
                return this.horizontalAlignment;
            }
            set
            {
                this.horizontalAlignment = value;
            }
        }

        #endregion
        #region  - Margins

        /// <summary>
        /// 
        /// </summary>
        public override Margins Margins
        {
            get
            {
                return this.margins;
            }
        }

        #endregion
        #region   - RowCount

        /// <summary>
        ///  
        /// </summary>
        public int RowCount
        {
            get
            {
                return this.rowCount;
            }
        }

        #endregion
        #region   - ColumnCount

        /// <summary>
        ///  
        /// </summary>
        public int ColumnCount
        {
            get
            {
                return this.columnCount;
            }
        }

        #endregion
        #region     - HeaderBackgroundColorDescriptor

        /// <summary>
        ///    
        /// </summary>
        public ColorDescriptor HeaderBackgroundColorDescriptor { get; set; }

        #endregion
        #region     - RowBackgroundColorDescriptor

        /// <summary>
        ///    
        /// </summary>
        public ColorDescriptor RowBackgroundColorDescriptor { get; set; }

        #endregion
        #region  ü    - RowAlternativeBackgroundColorDescriptor

        /// <summary>
        ///  ü   
        /// </summary>
        public ColorDescriptor RowAlternativeBackgroundColorDescriptor { get; set; }

        #endregion
        #region Ʈ   - DefaultCharFormat

        /// <summary>
        /// Ʈ  
        /// </summary>
        public override RTFCharFormat DefaultCharFormat
        {
            get
            {
                if(this.defaultCharFormat == null)
                {
                    this.defaultCharFormat = new RTFCharFormat(-1, -1, 1);
                }

                return this.defaultCharFormat;
            }
        }

        #endregion
        #region    - TitleRowCount

        /// <summary>
        ///   
        /// </summary>
        public int TitleRowCount
        {
            get
            {
                return this.titleRowCount;
            }
            set
            {
                this.titleRowCount = value;
            }
        }

        #endregion
        #region  е 迭 - CellPaddingArray

        /// <summary>
        ///  е 迭
        /// </summary>
        public Margins[] CellPaddingArray
        {
            get
            {
                return this.cellPaddingArray;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region   - BlockHead

        /// <summary>
        ///  
        /// </summary>
        internal override string BlockHead
        {
            set
            {
                throw new Exception("BlockHead is not supported for tables.");
            }
        }

        #endregion
        #region   - BlockTail

        /// <summary>
        ///  
        /// </summary>
        internal override string BlockTail
        {
            set
            {
                throw new Exception("BlockHead is not supported for tables.");
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFTable(rowCount, columnCount, width, fontSize)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rowCount"> </param>
        /// <param name="columnCount"> </param>
        /// <param name="width"></param>
        /// <param name="fontSize"></param>
        public RTFTable(int rowCount, int columnCount, float width, float fontSize)
        {
            this.startNewPage           = false;
            this.horizontalAlignment    = HorizontalAlignment.None;
            this.margins                = new Margins();
            this.rowCount               = rowCount;
            this.columnCount            = columnCount;
            this.fontSize               = fontSize;
            this.representativeCellList = new List<RTFTableCell>();
            this.titleRowCount          = 0;
            this.cellPaddingArray       = new Margins[this.rowCount];

            if(this.rowCount < 1 || this.columnCount < 1)
            {
                throw new Exception("The number of rows or columns is less than 1.");
            }

            HeaderBackgroundColorDescriptor         = null;
            RowBackgroundColorDescriptor            = null;
            RowAlternativeBackgroundColorDescriptor = null;

            this.defaultCellWidth       = width / (float)columnCount;
            this.cellArray              = new RTFTableCell[this.rowCount][];
            this.rowHeightArray         = new float[this.rowCount];
            this.rowKeepInSamePageArray = new bool[this.rowCount];

            for(int i = 0; i < this.rowCount; i++)
            {
                this.cellArray[i]              = new RTFTableCell[this.columnCount];
                this.rowHeightArray[i]         = 0f;
                this.rowKeepInSamePageArray[i] = false;
                this.cellPaddingArray[i]       = new Margins();

                for(int j = 0; j < this.columnCount; j++)
                {
                    this.cellArray[i][j] = new RTFTableCell(this.defaultCellWidth, i, j, this);
                }
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ϱ - GetCell(rowIndex, columnIndex)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="rowIndex"> ε</param>
        /// <param name="columnIndex"> ε</param>
        /// <returns>RTF ̺ </returns>
        public RTFTableCell GetCell(int rowIndex, int columnIndex)
        {
            if(this.cellArray[rowIndex][columnIndex].IsMerged)
            {
                return this.cellArray[rowIndex][columnIndex].MergeInfo.RepresentativeCell;
            }

            return this.cellArray[rowIndex][columnIndex];
        }

        #endregion
        #region   ϱ - SetRowHeight(rowIndex, height)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="rowIndex"> ε</param>
        /// <param name="height"></param>
        public void SetRowHeight(int rowIndex, float height)
        {
            if(rowIndex < 0 || rowIndex >= this.rowCount)
            {
                throw new Exception("Row index out of range");
            }

            for(int i = 0; i < this.columnCount; i++)
            {
                if(this.cellArray[rowIndex][i].IsMerged && this.cellArray[rowIndex][i].MergeInfo.RepresentativeCell.MergeInfo.RowSpan > 1)
                {
                    throw new Exception("Row height cannot be set because some cell in this row has been merged.");
                }
            }

            this.rowHeightArray[rowIndex] = height;
        }

        #endregion
        #region  ʺ ϱ - SetColumnWidth(columnIndex, width)

        /// <summary>
        ///  ʺ ϱ
        /// </summary>
        /// <param name="columnIndex"> ε</param>
        /// <param name="width">ʺ</param>
        public void SetColumnWidth(int columnIndex, float width)
        {
            if(columnIndex < 0 || columnIndex >= this.columnCount)
            {
                throw new Exception("Column index out of range");
            }

            for(int i = 0; i < this.rowCount; i++)
            {
                if(this.cellArray[i][columnIndex].IsMerged)
                {
                    throw new Exception("Column width cannot be set because some cell in this column has been merged.");
                }
            }

            for(int i = 0; i < this.rowCount; i++)
            {
                this.cellArray[i][columnIndex].Width = width;
            }
        }

        #endregion
        #region      ϱ - SetRowKeepInSamePage(rowIndex, allow)

        /// <summary>
        ///      ϱ
        /// </summary>
        /// <param name="rowIndex"> ε</param>
        /// <param name="allow"> </param>
        public void SetRowKeepInSamePage(int rowIndex, bool allow)
        {
            if(rowIndex < 0 || rowIndex >= this.rowCount)
            {
                throw new Exception("Row index out of range");
            }

            this.rowKeepInSamePageArray[rowIndex] = allow;
        }

        #endregion
        #region ϱ - Merge(topRowIndex, leftColumnIndex, rowSpan, columnSpan)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="topRowIndex">  ε</param>
        /// <param name="leftColumnIndex">  ε</param>
        /// <param name="rowSpan"> </param>
        /// <param name="columnSpan"> </param>
        /// <returns>RTF ̺ </returns>
        public RTFTableCell Merge(int topRowIndex, int leftColumnIndex, int rowSpan, int columnSpan)
        {
            if(topRowIndex < 0 || topRowIndex >= this.rowCount)
            {
                throw new Exception("Row index out of range");
            }

            if(leftColumnIndex < 0 || leftColumnIndex >= this.columnCount)
            {
                throw new Exception("Column index out of range");
            }

            if(rowSpan < 1 || topRowIndex + rowSpan - 1 >= this.rowCount)
            {
                throw new Exception("Row span out of range.");
            }

            if(columnSpan < 1 || leftColumnIndex + columnSpan - 1 >= this.columnCount)
            {
                throw new Exception("Column span out of range.");
            }

            if(columnSpan == 1 && rowSpan == 1)
            {
                return GetCell(topRowIndex, leftColumnIndex);
            }

            for(int i = 0; i < rowSpan; i++)
            {
                for(int j = 0; j < columnSpan; j++)
                {
                    if(this.cellArray[topRowIndex + i][leftColumnIndex + j].IsMerged)
                    {
                        throw new Exception("Cannot merge cells because some of the cells has been merged.");
                    }
                }
            }

            float width = 0;

            for(int i = 0; i < rowSpan; i++)
            {
                for(int j = 0; j < columnSpan; j++)
                {
                    if(i == 0)
                    {
                        width += this.cellArray[topRowIndex][leftColumnIndex + j].Width;
                    }

                    this.cellArray[topRowIndex + i][leftColumnIndex + j].MergeInfo = new CellMergeInfo
                    (
                        i,
                        rowSpan,
                        j,
                        columnSpan,
                        this.cellArray[topRowIndex][leftColumnIndex]
                    );

                    if(i != 0 || j != 0)
                    {
                        this.cellArray[topRowIndex + i][leftColumnIndex + j].TransferBlocksTo
                        (
                            this.cellArray[topRowIndex + i][leftColumnIndex + j].MergeInfo.RepresentativeCell
                        );
                    }
                }
            }

            this.cellArray[topRowIndex][leftColumnIndex].Width = width;

            this.representativeCellList.Add(this.cellArray[topRowIndex][leftColumnIndex]);

            return this.cellArray[topRowIndex][leftColumnIndex];
        }

        #endregion
        #region  ׵θ ϱ - SetInnerBorder(style, width, colorDescriptor)

        /// <summary>
        ///  ׵θ ϱ
        /// </summary>
        /// <param name="style">׵θ Ÿ</param>
        /// <param name="width">ʺ</param>
        /// <param name="colorDescriptor"> </param>
        public void SetInnerBorder(BorderStyle style, float width, ColorDescriptor colorDescriptor)
        {
            for(int i = 0; i < this.rowCount; i++)
            {
                for(int j = 0; j < this.columnCount; j++)
                {
                    if(i == 0)
                    {
                        this.cellArray[i][j].Borders[Direction.Bottom].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Bottom].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Bottom].ColorDescriptor = colorDescriptor;
                    }
                    else if(i == this.rowCount - 1)
                    {
                        this.cellArray[i][j].Borders[Direction.Top].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Top].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Top].ColorDescriptor = colorDescriptor;
                    }
                    else
                    {
                        this.cellArray[i][j].Borders[Direction.Top   ].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Top   ].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Top   ].ColorDescriptor = colorDescriptor;

                        this.cellArray[i][j].Borders[Direction.Bottom].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Bottom].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Bottom].ColorDescriptor = colorDescriptor;
                    }

                    if(j == 0)
                    {
                        this.cellArray[i][j].Borders[Direction.Right].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Right].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Right].ColorDescriptor = colorDescriptor;
                    }
                    else if(j == this.columnCount - 1)
                    {
                        this.cellArray[i][j].Borders[Direction.Left].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Left].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Left].ColorDescriptor = colorDescriptor;
                    }
                    else
                    {
                        this.cellArray[i][j].Borders[Direction.Right].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Right].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Right].ColorDescriptor = colorDescriptor;

                        this.cellArray[i][j].Borders[Direction.Left].Width           = width;
                        this.cellArray[i][j].Borders[Direction.Left].Style           = style;
                        this.cellArray[i][j].Borders[Direction.Left].ColorDescriptor = colorDescriptor;
                    }
                }
            }
        }

        #endregion
        #region  ׵θ ϱ - SetInnerBorder(style, width)

        /// <summary>
        ///  ׵θ ϱ
        /// </summary>
        /// <param name="style">׵θ Ÿ</param>
        /// <param name="width">ʺ</param>
        public void SetInnerBorder(BorderStyle style, float width)
        {
            SetInnerBorder(style, width, new ColorDescriptor(0));
        }

        #endregion
        #region ܺ ׵θ ϱ - SetOuterBorder(style, width, colorDescriptor)

        /// <summary>
        /// ܺ ׵θ ϱ
        /// </summary>
        /// <param name="style">׵θ Ÿ</param>
        /// <param name="width">ʺ</param>
        /// <param name="colorDescriptor"> </param>
        public void SetOuterBorder(BorderStyle style, float width, ColorDescriptor colorDescriptor)
        {
            for(int i = 0; i < this.columnCount; i++)
            {
                this.cellArray[0][i].Borders[Direction.Top].Width           = width;
                this.cellArray[0][i].Borders[Direction.Top].Style           = style;
                this.cellArray[0][i].Borders[Direction.Top].ColorDescriptor = colorDescriptor;

                this.cellArray[this.rowCount - 1][i].Borders[Direction.Bottom].Width           = width;
                this.cellArray[this.rowCount - 1][i].Borders[Direction.Bottom].Style           = style;
                this.cellArray[this.rowCount - 1][i].Borders[Direction.Bottom].ColorDescriptor = colorDescriptor;
            }

            for(int i = 0; i < this.rowCount; i++)
            {
                this.cellArray[i][0].Borders[Direction.Left].Width           = width;
                this.cellArray[i][0].Borders[Direction.Left].Style           = style;
                this.cellArray[i][0].Borders[Direction.Left].ColorDescriptor = colorDescriptor;

                this.cellArray[i][this.columnCount - 1].Borders[Direction.Right].Width           = width;
                this.cellArray[i][this.columnCount - 1].Borders[Direction.Right].Style           = style;
                this.cellArray[i][this.columnCount - 1].Borders[Direction.Right].ColorDescriptor = colorDescriptor;
            }
        }

        #endregion
        #region ܺ ׵θ ϱ - SetOuterBorder(style, width)

        /// <summary>
        /// ܺ ׵θ ϱ
        /// </summary>
        /// <param name="style">׵θ Ÿ</param>
        /// <param name="width">ʺ</param>
        public void SetOuterBorder(BorderStyle style, float width)
        {
            SetOuterBorder(style, width, new ColorDescriptor(0));
        }

        #endregion
        #region  ׵θ  ϱ - SetHeaderBorderColors(outerColorDescriptor, innerColorDescriptor)

        /// <summary>
        ///  ׵θ  ϱ
        /// </summary>
        /// <param name="outerColorDescriptor">ܺ  </param>
        /// <param name="innerColorDescriptor">  </param>
        public void SetHeaderBorderColors(ColorDescriptor outerColorDescriptor, ColorDescriptor innerColorDescriptor)
        {
            for(int j = 0; j < this.columnCount; j++)
            {
                this.cellArray[0][j].Borders[Direction.Top   ].ColorDescriptor = outerColorDescriptor;
                this.cellArray[0][j].Borders[Direction.Bottom].ColorDescriptor = innerColorDescriptor;

                if(j == 0)
                {
                    this.cellArray[0][j].Borders[Direction.Right].ColorDescriptor = innerColorDescriptor;
                    this.cellArray[0][j].Borders[Direction.Left ].ColorDescriptor = outerColorDescriptor;
                }
                else if(j == this.columnCount - 1)
                {
                    this.cellArray[0][j].Borders[Direction.Right].ColorDescriptor = outerColorDescriptor;
                    this.cellArray[0][j].Borders[Direction.Left ].ColorDescriptor = innerColorDescriptor;
                }
                else
                {
                    this.cellArray[0][j].Borders[Direction.Right].ColorDescriptor = innerColorDescriptor;
                    this.cellArray[0][j].Borders[Direction.Left ].ColorDescriptor = innerColorDescriptor;
                }
            }
        }

        #endregion

        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            StringBuilder stringBuilder = new StringBuilder();

            ValidateAllMergedCellBorders();

            if(this.defaultCharFormat != null)
            {
                for(int i = 0; i < this.rowCount; i++)
                {
                    for(int j = 0; j < this.columnCount; j++)
                    {
                        if(this.cellArray[i][j].IsMerged && this.cellArray[i][j].MergeInfo.RepresentativeCell != this.cellArray[i][j])
                        {
                            continue;
                        }

                        if(this.cellArray[i][j].DefaultCharFormat != null)
                        {
                            this.cellArray[i][j].DefaultCharFormat.CopyFrom(this.defaultCharFormat);
                        }
                    }
                }
            }

            float topMargin = this.margins[Direction.Top] - this.fontSize;

            if(this.startNewPage || topMargin > 0)
            {
                stringBuilder.Append(@"{\pard");

                if(this.startNewPage)
                {
                    stringBuilder.Append(@"\pagebb");
                }

                if(this.margins[Direction.Top] >= 0)
                {
                    stringBuilder.Append(@"\sl-" + RTFUtility.ConvertPointToTwip(topMargin));
                }
                else
                {
                    stringBuilder.Append(@"\sl-1");
                }

                stringBuilder.AppendLine(@"\slmult0\par}");
            }

            int columnAccumulator;

            for(int i = 0; i < this.rowCount; i++)
            {
                columnAccumulator = 0;

                stringBuilder.Append
                (
                    @"{\trowd\trgaph" + string.Format
                    (
                        @"\trpaddl{0}\trpaddt{1}\trpaddr{2}\trpaddb{3}",
                        RTFUtility.ConvertPointToTwip(CellPaddingArray[i][Direction.Left  ]),
                        RTFUtility.ConvertPointToTwip(CellPaddingArray[i][Direction.Top   ]),
                        RTFUtility.ConvertPointToTwip(CellPaddingArray[i][Direction.Right ]),
                        RTFUtility.ConvertPointToTwip(CellPaddingArray[i][Direction.Bottom])
                    )
                );

                switch(this.horizontalAlignment)
                {
                    case HorizontalAlignment.Left         : stringBuilder.Append(@"\trql"); break;
                    case HorizontalAlignment.Right        : stringBuilder.Append(@"\trqr"); break;
                    case HorizontalAlignment.Center       : stringBuilder.Append(@"\trqc"); break;
                    case HorizontalAlignment.FullyJustify : stringBuilder.Append(@"\trqj"); break;
                }

                stringBuilder.AppendLine();

                if(this.margins[Direction.Left] >= 0)
                {
                    stringBuilder.AppendLine(@"\trleft" + RTFUtility.ConvertPointToTwip(this.margins[Direction.Left]));

                    columnAccumulator = RTFUtility.ConvertPointToTwip(this.margins[Direction.Left]);
                }

                if(this.rowHeightArray[i] > 0)
                {
                    stringBuilder.Append(@"\trrh" + RTFUtility.ConvertPointToTwip(this.rowHeightArray[i]));
                }

                if(this.rowKeepInSamePageArray[i])
                {
                    stringBuilder.Append(@"\trkeep");
                }

                if(i < this.titleRowCount)
                {
                    stringBuilder.Append(@"\trhdr");
                }

                stringBuilder.AppendLine();

                for(int j = 0; j < this.columnCount; j++)
                {
                    if(this.cellArray[i][j].IsMerged && !this.cellArray[i][j].IsBeginOfColumnSpan)
                    {
                        continue;
                    }

                    float nextCellLeftBorderClearance = j < this.columnCount - 1 ? GetCell(i, j + 1).OuterLeftBorderClearance : 0;

                    columnAccumulator += RTFUtility.ConvertPointToTwip(GetCell(i, j).Width);

                    int columnRightPosition = columnAccumulator;

                    if(nextCellLeftBorderClearance < 0)
                    {
                        columnRightPosition += RTFUtility.ConvertPointToTwip(nextCellLeftBorderClearance);

                        columnRightPosition = columnRightPosition == 0 ? 1 : columnRightPosition;
                    }

                    for(Direction direction = Direction.Top; direction <= Direction.Left; direction++)
                    {
                        Border border = GetCell(i, j).Borders[direction];

                        if(border.Style != BorderStyle.None)
                        {
                            stringBuilder.Append(@"\clbrdr");

                            switch(direction)
                            {
                                case Direction.Top    : stringBuilder.Append("t"); break;
                                case Direction.Right  : stringBuilder.Append("r"); break;
                                case Direction.Bottom : stringBuilder.Append("b"); break;
                                case Direction.Left   : stringBuilder.Append("l"); break;
                            }

                            stringBuilder.Append(@"\brdrw" + RTFUtility.ConvertPointToTwip(border.Width));

                            stringBuilder.Append(@"\brdr");

                            switch(border.Style)
                            {
                                case BorderStyle.Single : stringBuilder.Append("s"   ); break;
                                case BorderStyle.Dotted : stringBuilder.Append("dot" ); break;
                                case BorderStyle.Dashed : stringBuilder.Append("dash"); break;
                                case BorderStyle.Double : stringBuilder.Append("db"  ); break;
                                default                 : throw new Exception("Unkown border style");
                            }

                            stringBuilder.Append(@"\brdrcf" + border.ColorDescriptor.Value);
                        }
                    }

                    if(GetCell(i, j).BackgroundColorDescriptor != null)
                    {
                        stringBuilder.Append(string.Format(@"\clcbpat{0}", GetCell(i, j).BackgroundColorDescriptor.Value));
                    }
                    else if(i == 0 && HeaderBackgroundColorDescriptor != null)
                    {
                        stringBuilder.Append(string.Format(@"\clcbpat{0}", HeaderBackgroundColorDescriptor.Value));
                    }
                    else if(RowBackgroundColorDescriptor != null && (RowAlternativeBackgroundColorDescriptor == null || i % 2 == 0))
                    {
                        stringBuilder.Append(string.Format(@"\clcbpat{0}", RowBackgroundColorDescriptor.Value));
                    }
                    else if(RowBackgroundColorDescriptor != null && RowAlternativeBackgroundColorDescriptor != null && i % 2 != 0)
                    {
                        stringBuilder.Append(string.Format(@"\clcbpat{0}", RowAlternativeBackgroundColorDescriptor.Value));
                    }

                    if(this.cellArray[i][j].IsMerged && this.cellArray[i][j].MergeInfo.RowSpan > 1)
                    {
                        if(this.cellArray[i][j].IsBeginOfRowSpan)
                        {
                            stringBuilder.Append(@"\clvmgf");
                        }
                        else
                        {
                            stringBuilder.Append(@"\clvmrg");
                        }
                    }

                    switch(this.cellArray[i][j].VerticalAlignment)
                    {
                        case VerticalAlignment.Top    : stringBuilder.Append(@"\clvertalt"); break;
                        case VerticalAlignment.Middle : stringBuilder.Append(@"\clvertalc"); break;
                        case VerticalAlignment.Bottom : stringBuilder.Append(@"\clvertalb"); break;
                    }

                    stringBuilder.AppendLine(@"\cellx" + columnRightPosition);
                }

                for(int j = 0; j < this.columnCount; j++)
                {
                    if(!this.cellArray[i][j].IsMerged || this.cellArray[i][j].IsBeginOfColumnSpan)
                    {
                        stringBuilder.Append(this.cellArray[i][j].Render());
                    }
                }

                stringBuilder.AppendLine(@"\row}");
            }

            if(this.margins[Direction.Bottom] >= 0)
            {
                stringBuilder.Append(@"\sl-" + RTFUtility.ConvertPointToTwip(this.margins[Direction.Bottom]) + @"\slmult");
            }

            return stringBuilder.ToString();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region   ׵θ ϱ - ValidateMergedCellBorder(representativeCell, direction)

        /// <summary>
        ///   ׵θ ϱ
        /// </summary>
        /// <param name="representativeCell">ǥ </param>
        /// <param name="direction"></param>
        private void ValidateMergedCellBorder(RTFTableCell representativeCell, Direction direction)
        {
            if(!representativeCell.IsMerged)
            {
                throw new Exception("Invalid representative (cell is not merged).");
            }

            Dictionary<Border, int> borderDictionary = new Dictionary<Border, int>();

            Border majorityBorder;
            int    majorityCount;
            int    limit = (direction == Direction.Top || direction == Direction.Bottom) ? representativeCell.MergeInfo.ColumnSpan : representativeCell.MergeInfo.RowSpan;

            for(int i = 0; i < limit; i++)
            {
                int    rowIndex;
                int    columnIndex;
                Border border;

                if(direction == Direction.Top || direction == Direction.Bottom)
                {
                    if(direction == Direction.Top)
                    {
                        rowIndex = 0;
                    }
                    else
                    {
                        rowIndex = representativeCell.MergeInfo.RowSpan - 1;
                    }

                    columnIndex = i;
                }
                else
                {
                    if(direction == Direction.Right)
                    {
                        columnIndex = representativeCell.MergeInfo.ColumnSpan - 1;
                    }
                    else
                    {
                        columnIndex = 0;
                    }

                    rowIndex = i;
                }

                border = this.cellArray[representativeCell.RowIndex + rowIndex][representativeCell.ColumnIndex + columnIndex].Borders[direction];

                if(borderDictionary.ContainsKey(border))
                {
                    borderDictionary[border] = (int)borderDictionary[border] + 1;
                }
                else
                {
                    borderDictionary[border] = 1;
                }
            }

            majorityCount  = -1;
            majorityBorder = representativeCell.Borders[direction];

            foreach(KeyValuePair<Border, int> keyValuePair in borderDictionary)
            {
                if(keyValuePair.Value > majorityCount)
                {
                    majorityCount = keyValuePair.Value;

                    majorityBorder.Width           = keyValuePair.Key.Width;
                    majorityBorder.Style           = keyValuePair.Key.Style;
                    majorityBorder.ColorDescriptor = keyValuePair.Key.ColorDescriptor;
                }
            }
        }

        #endregion
        #region    ׵θ ϱ - ValidateAllMergedCellBorders(representativeCell)

        /// <summary>
        ///    ׵θ ϱ
        /// </summary>
        /// <param name="representativeCell">ǥ </param>
        private void ValidateMergedCellBorders(RTFTableCell representativeCell)
        {
            if(!representativeCell.IsMerged)
            {
                throw new Exception("Invalid representative (cell is not merged).");
            }

            ValidateMergedCellBorder(representativeCell, Direction.Top   );
            ValidateMergedCellBorder(representativeCell, Direction.Right );
            ValidateMergedCellBorder(representativeCell, Direction.Bottom);
            ValidateMergedCellBorder(representativeCell, Direction.Left  );
        }

        #endregion
        #region    ׵θ ϱ - ValidateAllMergedCellBorders()

        /// <summary>
        ///    ׵θ ϱ
        /// </summary>
        private void ValidateAllMergedCellBorders()
        {
            for(int i = 0; i < this.representativeCellList.Count; i++)
            {
                ValidateMergedCellBorders(this.representativeCellList[i]);
            }
        }

        #endregion
    }
}