using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF ̺ 
    /// </summary>
    public class RTFTableCell : RTFBlockList
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///  
        /// </summary>
        private HorizontalAlignment horizontalAlignment;

        /// <summary>
        ///  
        /// </summary>
        private VerticalAlignment verticalAlignment;

        /// <summary>
        /// ʺ
        /// </summary>
        private float width;

        /// <summary>
        /// ׵θ
        /// </summary>
        private Borders borders;

        /// <summary>
        ///  
        /// </summary>
        private CellMergeInfo mergeInfo;

        /// <summary>
        ///  ε
        /// </summary>
        private int rowIndex;

        /// <summary>
        ///  ε
        /// </summary>
        private int columnIndex;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ε - RowIndex

        /// <summary>
        ///  ε
        /// </summary>
        public int RowIndex
        {
            get
            {
                return this.rowIndex;
            }
        }

        #endregion
        #region  ε - ColumnIndex

        /// <summary>
        ///  ε
        /// </summary>
        public int ColumnIndex
        {
            get
            {
                return this.columnIndex;
            }
        }

        #endregion
        #region ʺ - Width

        /// <summary>
        /// ʺ
        /// </summary>
        public float Width
        {
            get
            {
                return this.width;
            }
            set
            {
                this.width = value;
            }
        }

        #endregion
        #region   - IsMerged

        /// <summary>
        ///  
        /// </summary>
        public bool IsMerged
        {
            get
            {
                if(this.mergeInfo == null)
                {
                    return false;
                }

                return true;
            }
        }

        #endregion
        #region ׵θ - Borders

        /// <summary>
        /// ׵θ
        /// </summary>
        public Borders Borders
        {
            get
            {
                return this.borders;
            }
        }

        #endregion
        #region ܺ  ׵θ  - OuterLeftBorderClearance

        /// <summary>
        /// ܺ  ׵θ 
        /// </summary>
        public float OuterLeftBorderClearance { get; set; }

        #endregion
        #region   - HorizontalAlignment

        /// <summary>
        ///  
        /// </summary>
        public HorizontalAlignment HorizontalAlignment
        {
            get
            {
                return this.horizontalAlignment;
            }
            set
            {
                this.horizontalAlignment = value;
            }
        }

        #endregion
        #region   - VerticalAlignment

        /// <summary>
        ///  
        /// </summary>
        public VerticalAlignment VerticalAlignment
        {
            get
            {
                return this.verticalAlignment;
            }
            set
            {
                this.verticalAlignment = value;
            }
        }

        #endregion
        #region θ ̺ - ParentTable

        /// <summary>
        /// θ ̺
        /// </summary>
        public RTFTable ParentTable { get; private set; }

        #endregion
        #region    - BackgroundColorDescriptor

        /// <summary>
        ///   
        /// </summary>
        public ColorDescriptor BackgroundColorDescriptor { get; set; }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region   - MergeInfo

        /// <summary>
        ///  
        /// </summary>
        internal CellMergeInfo MergeInfo
        {
            get
            {
                return this.mergeInfo;
            }
            set
            {
                this.mergeInfo = value;
            }
        }

        #endregion
        #region     - IsBeginOfRowSpan

        /// <summary>
        ///    
        /// </summary>
        internal bool IsBeginOfRowSpan
        {
            get
            {
                if(this.mergeInfo == null)
                {
                    return false;
                }

                return (this.mergeInfo.RowIndex == 0);
            }
        }

        #endregion
        #region     - IsBeginOfColumnSpan

        /// <summary>
        /// ÿ   
        /// </summary>
        internal bool IsBeginOfColumnSpan
        {
            get
            {
                if(this.mergeInfo == null)
                {
                    return false;
                }

                return (this.mergeInfo.ColumnIndex == 0);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  - RTFTableCell(width, rowIndex, columnIndex, parentTable)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="width">ʺ</param>
        /// <param name="rowIndex"> ε</param>
        /// <param name="columnIndex"> ε</param>
        /// <param name="parentTable">θ ̺</param>
        internal RTFTableCell(float width, int rowIndex, int columnIndex, RTFTable parentTable) : base(true, false)
        {
            this.horizontalAlignment = HorizontalAlignment.None;
            this.verticalAlignment   = VerticalAlignment.Top;
            this.width               = width;
            this.borders             = new Borders();
            this.mergeInfo           = null;
            this.rowIndex            = rowIndex;
            this.columnIndex         = columnIndex;

            BackgroundColorDescriptor = null;
            ParentTable      = parentTable;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ׵θ  ϱ - SetBorderColor(colorDescriptor)

        /// <summary>
        /// ׵θ  ϱ
        /// </summary>
        /// <param name="colorDescriptor"> </param>
        public void SetBorderColor(ColorDescriptor colorDescriptor)
        {
            this.Borders[Direction.Top   ].ColorDescriptor = colorDescriptor;
            this.Borders[Direction.Bottom].ColorDescriptor = colorDescriptor;
            this.Borders[Direction.Left  ].ColorDescriptor = colorDescriptor;
            this.Borders[Direction.Right ].ColorDescriptor = colorDescriptor;
        }

        #endregion
        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            StringBuilder stringBuilder = new StringBuilder();

            string alignment = string.Empty;
            
            switch(this.horizontalAlignment)
            {
                case HorizontalAlignment.Left         : alignment = @"\ql"; break;
                case HorizontalAlignment.Right        : alignment = @"\qr"; break;
                case HorizontalAlignment.Center       : alignment = @"\qc"; break;
                case HorizontalAlignment.FullyJustify : alignment = @"\qj"; break;
                case HorizontalAlignment.Distributed  : alignment = @"\qd"; break;
            }

            if(base.blockList.Count <= 0)
            {
                stringBuilder.AppendLine(@"\pard\intbl");
            }
            else
            {
                for(int i = 0; i < base.blockList.Count; i++)
                {
                    RTFBlock block = (RTFBlock) base.blockList[i];

                    if(defaultCharFormat != null && block.DefaultCharFormat != null)
                    {
                        block.DefaultCharFormat.CopyFrom(defaultCharFormat);
                    }

                    if(block.Margins[Direction.Top] < 0)
                    {
                        block.Margins[Direction.Top] = 0;
                    }

                    if(block.Margins[Direction.Right] < 0)
                    {
                        block.Margins[Direction.Right] = 0;
                    }

                    if(block.Margins[Direction.Bottom] < 0)
                    {
                        block.Margins[Direction.Bottom] = 0;
                    }

                    if(block.Margins[Direction.Left] < 0)
                    {
                        block.Margins[Direction.Left] = 0;
                    }

                    if(i == 0)
                    {
                        block.BlockHead = @"\pard\intbl" + alignment;
                    }
                    else
                    {
                        block.BlockHead = @"\par" + alignment;
                    }

                    block.BlockTail = string.Empty;

                    stringBuilder.AppendLine(block.Render());
                }
            }

            stringBuilder.AppendLine(@"\cell");

            return stringBuilder.ToString();
        }

        #endregion
    }
}