using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;

using TestLibrary;

namespace TestPrjoect
{
    /// <summary>
    /// α׷
    /// </summary>
    internal class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        private static RTFDocument _document = null;

        /// <summary>
        /// Ʈ ųʸ
        /// </summary>
        private static Dictionary<string, FontDescriptor> _fontNameDictionary = new Dictionary<string, FontDescriptor>();

        /// <summary>
        ///  ųʸ
        /// </summary>
        private static Dictionary<Color, ColorDescriptor> _colorDictionary = new Dictionary<Color, ColorDescriptor>();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Ʈ  ϱ - GetFontDescriptor(fontName)

        /// <summary>
        /// Ʈ  ϱ
        /// </summary>
        /// <param name="fontName">Ʈ</param>
        /// <returns>Ʈ </returns>
        private static FontDescriptor GetFontDescriptor(string fontName)
        {
            if(_fontNameDictionary.ContainsKey(fontName))
            {
                return _fontNameDictionary[fontName];
            }
            else
            {
                FontDescriptor descriptor = _document.CreateFontDescriptor(fontName);

                _fontNameDictionary.Add(fontName, descriptor);

                return descriptor;
            }
        }

        #endregion
        #region   ϱ - GetColorDescriptor(color)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="color"></param>
        /// <returns> </returns>
        private static ColorDescriptor GetColorDescriptor(Color color)
        {
            if(_colorDictionary.ContainsKey(color))
            {
                return _colorDictionary[color];
            }
            else
            {
                ColorDescriptor descriptor = _document.CreateColorDescriptor(color);

                _colorDictionary.Add(color, descriptor);

                return descriptor;
            }
        }

        #endregion

        #region  ϱ - SetParagraph(paragraph, alignment, fontName, fontSize, textColor, text)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="paragraph">RTF </param>
        /// <param name="alignment"> </param>
        /// <param name="fontName">Ʈ</param>
        /// <param name="fontSize">Ʈ ũ</param>
        /// <param name="textColor">ؽƮ </param>
        /// <param name="text">ؽƮ</param>
        private static void SetParagraph(RTFParagraph paragraph, HorizontalAlignment? alignment, string fontName, float? fontSize, Color? textColor, string text)
        {
            if(alignment.HasValue)
            {
                paragraph.HorizontalAlignment = alignment.Value;
            }

            if(fontName != null)
            {
                paragraph.DefaultCharFormat.FontDescriptor = GetFontDescriptor(fontName);
            }

            if(fontSize.HasValue)
            {
                paragraph.DefaultCharFormat.FontSize = fontSize.Value;
            }

            if(textColor.HasValue)
            {
                paragraph.DefaultCharFormat.ForegroundColorDescriptor = GetColorDescriptor(textColor.Value);
            }

            if(text != null)
            {
                paragraph.SetText(text);
            }
        }

        #endregion
        #region   ߰ϱ - AddHeaderParagraph(alignment, fontName, fontSize, textColor, text)

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <param name="alignment"> </param>
        /// <param name="fontName">Ʈ</param>
        /// <param name="fontSize">Ʈ ũ</param>
        /// <param name="textColor">ؽƮ </param>
        /// <param name="text">ؽƮ</param>
        /// <returns>RTF </returns>
        private static RTFParagraph AddHeaderParagraph(HorizontalAlignment? alignment, string fontName, float? fontSize, Color? textColor, string text)
        {
            RTFParagraph paragraph = _document.Header.AddParagraph();

            SetParagraph(paragraph, alignment, fontName, fontSize, textColor, text);

            return paragraph;
        }

        #endregion
        #region ٴڱ  ߰ϱ - AddFooterParagraph(alignment, fontName, fontSize, textColor, text)

        /// <summary>
        /// ٴڱ  ߰ϱ
        /// </summary>
        /// <param name="alignment"> </param>
        /// <param name="fontName">Ʈ</param>
        /// <param name="fontSize">Ʈ ũ</param>
        /// <param name="textColor">ؽƮ </param>
        /// <param name="text">ؽƮ</param>
        /// <returns>RTF </returns>
        private static RTFParagraph AddFooterParagraph(HorizontalAlignment? alignment, string fontName, float? fontSize, Color? textColor, string text)
        {
            RTFParagraph paragraph = _document.Footer.AddParagraph();

            SetParagraph(paragraph, alignment, fontName, fontSize, textColor, text);

            return paragraph;
        }

        #endregion
        #region   ߰ϱ - AddEmptyParagraph()

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <returns>RTF </returns>
        private static RTFParagraph AddEmptyParagraph()
        {
            RTFParagraph paragraph = _document.AddParagraph();

            return paragraph;
        }

        #endregion
        #region  ߰ϱ - AddParagraph(alignment, fontName, fontSize, textColor, text)

        /// <summary>
        ///  ߰ϱ
        /// </summary>
        /// <param name="alignment"> </param>
        /// <param name="fontName">Ʈ</param>
        /// <param name="fontSize">Ʈ ũ</param>
        /// <param name="textColor">ؽƮ </param>
        /// <param name="text">ؽƮ</param>
        /// <returns>RTF </returns>
        private static RTFParagraph AddParagraph(HorizontalAlignment? alignment, string fontName, float? fontSize, Color? textColor, string text)
        {
            RTFParagraph paragraph = _document.AddParagraph();

            SetParagraph(paragraph, alignment,fontName, fontSize, textColor, text);

            return paragraph;
        }

        #endregion
        #region   ߰ϱ - AddCharFormat(paragraph, startIndex, endIndex, fontName, fontSize, backgroundColor, foregroundColor)

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <param name="paragraph">RTF </param>
        /// <param name="startIndex"> ε</param>
        /// <param name="endIndex"> ε</param>
        /// <param name="fontName">Ʈ</param>
        /// <param name="fontSize">Ʈ ũ</param>
        /// <param name="backgroundColor"> </param>
        /// <param name="foregroundColor"> </param>
        /// <returns>RTF  </returns>
        private static RTFCharFormat AddCharFormat
        (
            RTFParagraph paragraph,
            int          startIndex,
            int          endIndex,
            string       fontName,
            float?       fontSize,
            Color?       backgroundColor,
            Color?       foregroundColor
        )
        {
            RTFCharFormat format = paragraph.AddCharFormat(startIndex, endIndex);

            if(fontName != null)
            {
                format.FontDescriptor = GetFontDescriptor(fontName);
            }

            if(fontSize.HasValue)
            {
                format.FontSize = fontSize.Value;
            }

            if(backgroundColor.HasValue)
            {
                format.BackgroundColorDescriptor = GetColorDescriptor(backgroundColor.Value);
            }

            if(foregroundColor.HasValue)
            {
                format.ForegroundColorDescriptor = GetColorDescriptor(foregroundColor.Value);
            }

            return format;
        }

        #endregion
        #region Ÿ ߰ϱ - AddStyle(format, fontStyleFlag)

        /// <summary>
        /// Ÿ ߰ϱ
        /// </summary>
        /// <param name="format">RTF  </param>
        /// <param name="fontStyleFlag">Ʈ Ÿ ÷</param>
        private static void AddStyle(RTFCharFormat format, FontStyleFlag fontStyleFlag)
        {
            format.FontStyle.AddStyle(fontStyleFlag);
        }

        #endregion
        #region  ߰ϱ - AddFootnote(paragraph, footnoteIndex)

        /// <summary>
        ///  ߰ϱ
        /// </summary>
        /// <param name="paragraph">RTF </param>
        /// <param name="footnoteIndex"> ε</param>
        /// <returns>RTF </returns>
        private static RTFFootnote AddFootnote(RTFParagraph paragraph, int footnoteIndex)
        {
            RTFFootnote footnote = paragraph.AddFootnote(footnoteIndex);

            return footnote;
        }

        #endregion
        #region   ߰ϱ - AddFootnoteParagraph(footnote, fontName, fontSize, textColor, text)

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <param name="footnote">RTF </param>
        /// <param name="fontName">Ʈ</param>
        /// <param name="fontSize">Ʈ ũ</param>
        /// <param name="textColor">ؽƮ </param>
        /// <param name="text">ؽƮ</param>
        /// <returns>RTF </returns>
        private static RTFParagraph AddFootnoteParagraph(RTFFootnote footnote, string fontName, float? fontSize, Color? textColor, string text)
        {
            RTFParagraph paragraph = footnote.AddParagraph();

            SetParagraph(paragraph, null, fontName, fontSize, textColor, text);

            return paragraph;
        }

        #endregion
        #region   ߰ϱ - AddControlWord(paragraph, index, .fieldType)

        /// <summary>
        ///   ߰ϱ
        /// </summary>
        /// <param name="paragraph">RTF </param>
        /// <param name="index">ε</param>
        /// <param name="fieldType">ʵ Ÿ</param>
        private static void AddControlWord(RTFParagraph paragraph, int index, RTFFieldControlWord.FieldType fieldType)
        {
            paragraph.AddControlWord(index, fieldType);
        }

        #endregion
        #region ̹ ߰ϱ - AddImage(filePath, imageFileType, startNewParagraph, alignment, width, height)

        /// <summary>
        /// ̹ ߰ϱ
        /// </summary>
        /// <param name="filePath"> </param>
        /// <param name="imageFileType">̹  Ÿ</param>
        /// <param name="startNewParagraph">   </param>
        /// <param name="alignment"> </param>
        /// <param name="width">ʺ</param>
        /// <param name="height"></param>
        /// <returns>RTF ̹</returns>
        private static RTFImage AddImage(string filePath, ImageFileType imageFileType, bool? startNewParagraph, HorizontalAlignment? alignment, float? width, float? height)
        {
            RTFImage image = _document.AddImage(filePath, imageFileType);

            if(startNewParagraph.HasValue)
            {
                image.StartNewParagraph = startNewParagraph.Value;
            }

            if(alignment.HasValue)
            {
                image.HorizontalAlignment = alignment.Value;
            }

            if(width.HasValue)
            {
                image.Width = width.Value;
            }

            if(height.HasValue)
            {
                image.Height = height.Value;
            }

            return image;
        }

        #endregion

        #region α׷ ϱ - Main()

        /// <summary>
        /// α׷ ϱ
        /// </summary>
        private static void Main()
        {
            #region  Ѵ.

            _document = new RTFDocument(PaperSize.A4, PaperOrientation.Landscape, LCID.Korean);

            _document.DefaultCharFormat.FontDescriptor            = GetFontDescriptor("ڵ");
            _document.DefaultCharFormat.FontSize                  = 12f;
            _document.DefaultCharFormat.ForegroundColorDescriptor = GetColorDescriptor(Color.Black);

            #endregion
            #region  ߰Ѵ.

            RTFParagraph paragraph1 = AddHeaderParagraph(HorizontalAlignment.Center, null, null, Color.DarkGray, " ");

            #endregion
            #region ٴڱ ߰Ѵ.

            RTFParagraph paragraph2 = AddFooterParagraph(HorizontalAlignment.Center, null, null, Color.DarkGray, " :  / , ¥ : , ð : ");

            AddControlWord(paragraph2, 5 , RTFFieldControlWord.FieldType.PageNumber);
            AddControlWord(paragraph2, 8 , RTFFieldControlWord.FieldType.PageCount );
            AddControlWord(paragraph2, 15, RTFFieldControlWord.FieldType.Date      );
            AddControlWord(paragraph2, 22, RTFFieldControlWord.FieldType.Time      );

            #endregion
            #region  ߰Ѵ.

            AddEmptyParagraph();

            AddParagraph(HorizontalAlignment.Left  , null, null, null, "Ϲ  Դϴ.");
            AddParagraph(HorizontalAlignment.Center, null, null, null, "Ϲ  Դϴ.");
            AddParagraph(HorizontalAlignment.Right , null, null, null, "Ϲ  Դϴ.");

            #endregion
            #region ܿ Ư ڿ  Ѵ.

            AddEmptyParagraph();

            RTFParagraph paragraph3 = AddParagraph(HorizontalAlignment.Left, null, null, null, "123456789");
            RTFParagraph paragraph4 = AddParagraph(HorizontalAlignment.Left, null, null, null, "123456789");
            RTFParagraph paragraph5 = AddParagraph(HorizontalAlignment.Left, null, null, null, "123456789");

            RTFCharFormat format1 = AddCharFormat(paragraph3, 0, 2, null, null, Color.Red  , Color.White);
            RTFCharFormat format2 = AddCharFormat(paragraph4, 3, 5, null, null, Color.Green, Color.White);
            RTFCharFormat format3 = AddCharFormat(paragraph5, 6, 8, null, null, Color.Blue , Color.White);

            AddStyle(format1, FontStyleFlag.Italic   );
            AddStyle(format2, FontStyleFlag.Bold     );
            AddStyle(format3, FontStyleFlag.Underline);

            #endregion
            #region ָ ߰Ѵ.

            AddEmptyParagraph();

            RTFParagraph paragraph6 = AddParagraph(null, null, null, null, " ׽Ʈ ڿ Դϴ.");

            RTFFootnote footnote1 = AddFootnote(paragraph6, 14);

            AddFootnoteParagraph(footnote1, "ü", 10f, Color.Red, " ׽Ʈ ڿ Դϴ.");

            RTFParagraph paragraph7 = AddParagraph(null, null, null, null, " ׽Ʈ ڿ Դϴ.");

            RTFFootnote footnote2 = AddFootnote(paragraph7, 14);

            AddFootnoteParagraph(footnote2, "ü", 10f, Color.Blue, " ׽Ʈ ڿ Դϴ.");

            #endregion
            #region ̹ ߰Ѵ.

            AddEmptyParagraph();

            AddImage("IMAGE\\sample.png", ImageFileType.PNG, true, null, null, 100);

            #endregion
            #region ̺ ߰Ѵ.

            AddEmptyParagraph();

            RTFTable table = _document.AddTable(4, 4, 600, 12);

            table.SetInnerBorder(BorderStyle.Dotted, 1f);
            table.SetOuterBorder(BorderStyle.Single, 2f);

            table.HeaderBackgroundColorDescriptor = GetColorDescriptor(Color.DarkGreen);
            table.RowBackgroundColorDescriptor    = GetColorDescriptor(Color.White);

            for(int y = 0; y < table.RowCount; y++)
            {
                table.SetRowHeight(y, 25f);

                for(int x = 0; x < table.ColumnCount; x++)
                {
                    RTFTableCell cell1 = table.GetCell(y, x);

                    RTFParagraph paragraph8 = cell1.AddParagraph();
                    
                    SetParagraph(paragraph8, HorizontalAlignment.Center, null, null, null, $"({y},{x})");
                    
                    cell1.VerticalAlignment          = VerticalAlignment.Middle;
                    cell1.DefaultCharFormat.FontSize = 16f;
                }
            }

            table.Merge(1, 0, 3, 1);

            RTFTableCell cell2 = table.GetCell(3, 3);

            cell2.BackgroundColorDescriptor = GetColorDescriptor(Color.Red);

            #endregion
            #region ο Ÿ Ѵ.

            AddEmptyParagraph();

            RTFParagraph paragraph9 = AddParagraph(null, null, null, Color.DarkGray, "ٶ󸶹ٻīŸ");

            RTFCharFormat format4 = AddCharFormat(paragraph9, 5, 10, null, null, null, null);

            format4.TwoInOneStyle = TwoInOneStyle.SquareBrackets;

            #endregion
            #region ۸ũ ߰Ѵ.

            AddEmptyParagraph();

            RTFParagraph paragraph10 = AddParagraph(null, null, null, null, "۸ũ ڿ ߰մϴ.");

            RTFCharFormat format5 = AddCharFormat(paragraph10, 0, 4, null, null, null, Color.Blue);

            format5.LocalHyperlink    = "target";
            format5.LocalHyperlinkTip = "Ÿ մϴ.";

            #endregion
            #region ο  Ѵ.

            RTFParagraph paragraph11 = AddParagraph(null, null, null, null, "ο  մϴ.");

            paragraph11.StartNewPage = true;

            #endregion
            #region ϸũ Ѵ.

            RTFParagraph paragraph12 = AddParagraph(null, null, null, null, "target ϸũ մϴ.");

            RTFCharFormat format6 = AddCharFormat(paragraph12, 0, 17, null, null, null, null);

            format6.Bookmark = "target";

            #endregion
            #region RTF  Ѵ.

            _document.Save("demo.rtf");

            #endregion
            #region MS WORD Ѵ.

            Process process = new Process {StartInfo = {FileName = "demo.rtf"}};

            process.Start();

            #endregion
        }

        #endregion
    }
}